<?php

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  Script: Maian Support v1.3
  Written by: David Ian Bennett
  E-Mail: support@maianscriptworld.co.uk
  Website: http://www.maianscriptworld.co.uk

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  This File: index.php
  Description: Admin Parsing File

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

session_start();

//=====================================================================
// DEFINED VARIABLES
//=====================================================================
//
// INCLUDE_FILES      = For security when popups open.
// MAXENTRIES         = Amount of data to show per page
//                      (Only applicable with page numbers)
// PHPMAILER          = Enable PHP mailer system.
// REDIRECT_MESSAGE   = Enable/Disable redirect message
//                      1 = Show, 0 = No Show
// TICKET_REDIRECT    = If enabled, ticket is displayed after login
//                      1 = Show, 0 = No Show
// ENABLE_DD_MENU     = If set, disables the omni system menu and
//                      reverts back to drop down select box
//
//=====================================================================

define('INCLUDE_FILES', 1);
define('MAXENTRIES', 25);
define('REDIRECT_MESSAGE', 0);
define('TICKET_REDIRECT', 1);
define('ENABLE_DD_MENU', 1);

error_reporting(E_ALL);

// Set paths
define ('FOLDER_PATH', dirname(__FILE__).'/');
define ('RELATIVE_PATH', '../');

include(RELATIVE_PATH.'inc/db_connection.inc.php');
include(FOLDER_PATH.'inc/functions.php');
include(FOLDER_PATH.'classes/class_mail.inc.php');
include(FOLDER_PATH.'classes/PaginateIt.php');

set_magic_quotes_runtime(0);

//-----------------------------
// Load settings
//-----------------------------

$SETTINGS = mysql_fetch_object(mysql_query("SELECT *,UNIX_TIMESTAMP(exampledate) as prog_date 
                                            FROM ".$database['prefix']."settings 
                                            LIMIT 1
                                            ")) or die(mysql_error());

include(RELATIVE_PATH.'lang/'.$SETTINGS->language);

//--------------------------------
// Check for cookie/session data
//--------------------------------

if (isset($_SESSION['support_email']) && isset($_SESSION['support_pass']))
{
  $session_data = true;
}
if (isset($_COOKIE['support_cookie_email']) && isset($_COOKIE['support_cookie_pass']))
{
  $cookie_data  = true;
}

if (isset($session_data) || isset($cookie_data))
{
  $q_support = mysql_query("SELECT * FROM ".$database['prefix']."users 
                            WHERE email = '".(isset($session_data) ? $_SESSION['support_email'] : $_COOKIE['support_cookie_email'])."' 
                            AND accpass = '".(isset($session_data) ? md5($_SESSION['support_pass']) : md5($_COOKIE['support_cookie_pass']))."' 
                            LIMIT 1
                            ") or die(mysql_error());
  $MSP_SUPPORTTEAM = mysql_fetch_object($q_support);

  // If session variables are live and contain no data, prevent pages loading
  if (mysql_num_rows($q_support)==0)
  {
    session_unset();
    session_destroy();
    $_COOKIE['support_cookie_email'] = '';
    $_COOKIE['support_cookie_pass']  = '';
    header("Location: index.php?cmd=login");
    exit;
  }
}

$cmd           = (isset($_GET['cmd']) ? strip_tags($_GET['cmd']) : 'home');
$page          = (isset($_GET['page']) ? strip_tags($_GET['page']) : '1');
$count         = 0;
$limit         = MAXENTRIES;
$limitvalue    = $page * $limit - ($limit);
$error_string  = array();

//---------------------------------
// Run auto cron to close tickets
// Added in v1.3
//---------------------------------

if ($SETTINGS->autoClose>0)
{
  runAutoCron($SETTINGS->autoClose);
}

//--------------------------------------------------------------
// Create instance of mailing class and pass default variables
// Added in v1.3
//--------------------------------------------------------------

$MSP_MAIL             = new mailClass();
$MSP_MAIL->smtp       = $SETTINGS->smtp;
$MSP_MAIL->smtp_host  = $SETTINGS->smtp_host;
$MSP_MAIL->smtp_user  = $SETTINGS->smtp_user;
$MSP_MAIL->smtp_pass  = $SETTINGS->smtp_pass;
$MSP_MAIL->smtp_port  = $SETTINGS->smtp_port;
$MSP_MAIL->addTag('{SCRIPT_PATH}', $SETTINGS->script_path);
$MSP_MAIL->addTag('{WEBSITE_NAME}', $SETTINGS->website);
$MSP_MAIL->addTag('{WEBSITE_URL}', 'http://'.$_SERVER['HTTP_HOST']);

switch ($cmd)
{
     //===============
     // CASE: HOME
     //===============

     case "home":

     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }

     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/home.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;

     //=================
     // CASE: SETTINGS
     //=================

     case "settings":

     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }
     
     //----------------------
     // Check Permissions
     //----------------------
     
     if ($MSP_SUPPORTTEAM->admintype!='admin')
     {
       $error_string[] = $msg_script23;

       error($msg_script10,
             $msg_script9,
             $msg_charset,
             $error_string
             );
     }

     //-----------------------
     // SCRIPT ACTION
     // Update Settings
     //-----------------------
     
     if (isset($_GET['form']) && $_GET['form']=="update")
     {
       $lang           = $_POST['lang'];
       $website        = trim($_POST['website']);
       $email          = trim($_POST['email']);
       $path           = trim($_POST['path']);
       $date           = trim($_POST['date']);
       $timeOffset     = trim($_POST['timeOffset']);
       $enCaptcha      = (isset($_POST['enCaptcha']) ? $_POST['enCaptcha'] : '0');
       $auto_close     = (int)$_POST['auto_close'];
       $kbase          = (isset($_POST['kbase']) ? $_POST['kbase'] : '0');
       $ban_filters    = (isset($_POST['ban_filters']) ? $_POST['ban_filters'] : '0');
       $attach         = (isset($_POST['attach']) ? $_POST['attach'] : '0');
       $auto_zip       = (isset($_POST['auto_zip']) ? $_POST['auto_zip'] : '0');
       $filetypes      = trim($_POST['filetypes']);
       $maxsize        = trim($_POST['maxsize']);
       $enablelive     = (isset($_POST['enablelive']) ? $_POST['enablelive'] : '0');
       $liverefresh    = trim($_POST['liverefresh']);
       $timeout        = trim($_POST['timeout']);
       $enLiveCaptcha  = (isset($_POST['enLiveCaptcha']) ? $_POST['enLiveCaptcha'] : '0');
       $smtp           = (isset($_POST['smtp']) ? $_POST['smtp'] : '0');
       $smtp_host      = trim($_POST['smtp_host']);
       $smtp_user      = trim($_POST['smtp_user']);
       $smtp_pass      = trim($_POST['smtp_pass']);
       $smtp_port      = (int)$_POST['smtp_port'];

       include(FOLDER_PATH.'classes/class_settings.inc.php');
          
       $MSP_SETTINGS = new settings();
          
       if ($MSP_SETTINGS->field_check(0,150,$website))
       {
         $error_string[] = $msg_settings12;
       }
       if (!eregi("^([a-z]|[0-9]|\.|-|_)+@([a-z]|[0-9]|\.|-|_)+\.([a-z]|[0-9]){2,4}$", $email))
       {
         $error_string[] = $msg_livesupport5;
       }
       if ($MSP_SETTINGS->field_check(0,250,$path))
       {
         $error_string[] = $msg_settings32;
       }
       if ($MSP_SETTINGS->field_check(0,0,$date))
       {
         $error_string[] = $msg_settings8;
       }
       if ($maxsize && !ctype_digit($maxsize))
       {
         $error_string[] = $msg_settings9;
       }
       if ($error_string)
       {
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         $MSP_SETTINGS->prefix         = $database['prefix'];
         $MSP_SETTINGS->website        = $website;
         $MSP_SETTINGS->email          = $email;
         $MSP_SETTINGS->path           = $path;
         $MSP_SETTINGS->lang           = $lang;
         $MSP_SETTINGS->dateformat     = $date;
         $MSP_SETTINGS->timeOffset     = $timeOffset;
         $MSP_SETTINGS->enCaptcha      = $enCaptcha;
         $MSP_SETTINGS->auto_close     = $auto_close;
         $MSP_SETTINGS->ban_filters    = $ban_filters;
         $MSP_SETTINGS->kbase          = $kbase;
         $MSP_SETTINGS->attachment     = $attach;
         $MSP_SETTINGS->auto_zip       = $auto_zip;
         $MSP_SETTINGS->filetypes      = $filetypes;
         $MSP_SETTINGS->maxsize        = $maxsize;
         $MSP_SETTINGS->enablelive     = $enablelive;
         $MSP_SETTINGS->liverefresh    = ($liverefresh=='' || !ctype_digit($liverefresh) || strlen($liverefresh)>2 ? '4' : $liverefresh);
         $MSP_SETTINGS->timeout        = ($timeout=='' || !ctype_digit($timeout) || strlen($timeout)>2 || $timeout>59 ? '6' : $timeout);
         $MSP_SETTINGS->enLiveCaptcha  = $enLiveCaptcha;
         $MSP_SETTINGS->smtp           = $smtp;
         $MSP_SETTINGS->smtp_host      = $smtp_host;
         $MSP_SETTINGS->smtp_user      = $smtp_user;
         $MSP_SETTINGS->smtp_pass      = $smtp_pass;
         $MSP_SETTINGS->smtp_port      = $smtp_port;

         $MSP_SETTINGS->update_settings();

         updated($msg_settings10,
                 'index.php?cmd=settings',
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }

     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/settings.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;
     
     //===============
     // CASE: DEPT
     //===============

     case "dept":
     
     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }
     
     //----------------------
     // Check Permissions
     //----------------------
     
     if ($MSP_SUPPORTTEAM->admintype!='admin')
     {
       $error_string[] = $msg_script23;

       error($msg_script10,
             $msg_script9,
             $msg_charset,
             $error_string
             );
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Add Department
     //-----------------------
     
     if (isset($_GET['form']) && $_GET['form']=="add")
     {
       $name = trim($_POST['name']);
          
       include(FOLDER_PATH.'classes/class_depts.inc.php');
          
       $MSP_DEPT = new departments();
          
       if ($MSP_DEPT->field_check(0,100,$name))
       {
         $error_string[] = $msg_dept7;
       }
       if ($error_string)
       {
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         $MSP_DEPT->prefix  = $database['prefix'];
         $MSP_DEPT->name    = cleanData($name);
               
         if ($MSP_DEPT->add_dept())
         {
           updated($msg_dept8,
                   'index.php?cmd=dept',
                   $msg_script8,
                   $msg_script7,
                   $msg_charset
                   );
         }
         else
         {
           $error_string[] = $msg_dept12;
                    
           error($msg_script10,
                 $msg_script9,
                 $msg_charset,
                 $error_string
                 );
         }
       }
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Update Departments
     //-----------------------
     
     if (isset($_GET['form']) && $_GET['form']=="update")
     {
       $id    = $_POST['id'];
       $dept  = $_POST['dept'];

       include(FOLDER_PATH.'classes/class_depts.inc.php');

       for ($i=0; $i<count($id); $i++)
       {
         $MSP_DEPT = new departments();
               
         $MSP_DEPT->prefix  = $database['prefix'];
         $MSP_DEPT->id      = $id[$i];
         $MSP_DEPT->name    = cleanData($dept[$i]);

         if (!$MSP_DEPT->update_dept())
         {
           $count++;
         }
               
         unset($MSP_DEPT);
       }
          
       if ($count==0)
       {
         updated($msg_dept10,
                 'index.php?cmd=dept',
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
       else
       {
         $error_string[] = $msg_dept13;
               
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Delete Department
     //-----------------------
     
     if (isset($_GET['action']) && $_GET['action']=="delete")
     {
       $id = strip_tags($_GET['id']);
          
       if (ctype_digit($id))
       {
         mysql_query("DELETE FROM ".$database['prefix']."departments 
                      WHERE id = '$id' 
                      LIMIT 1
                      ") or die(mysql_error());
          
         updated($msg_dept9,
                 'index.php?cmd=dept',
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }

     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/dept.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;
     
     //===============
     // CASE: USERS
     //===============

     case "users":
     
     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }
     
     //----------------------
     // Check Permissions
     //----------------------
     
     if ($MSP_SUPPORTTEAM->admintype!='admin')
     {
       $error_string[] = $msg_script23;

       error($msg_script10,
             $msg_script9,
             $msg_charset,
             $error_string
             );
     }
     
     //-----------------------
     // Hide/show form
     // Added in v1.3
     //-----------------------
     
     if (isset($_GET['expand']))
     {
       switch ($_GET['expand'])
       {
         case 0:
         setcookie("msp_user_expand", '31407b18c5a9dd810565caedda2d0e42', time()+60*60*24*30);
         break;
         
         case 1:
         setcookie("msp_user_expand", "");
         break;
       }
       
       header("Location: index.php?cmd=users");
       exit;
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Add New User
     //-----------------------
     
     if (isset($_GET['form']) && $_GET['form']=="add")
     {
       $name         = trim($_POST['name']);
       $email        = $_POST['email'];
       $password     = trim($_POST['password']);
       $dept         = $_POST['dept'];
       $livesupport  = $_POST['livesupport'];
       $mod          = $_POST['mod'];
       $signature    = trim($_POST['signature']);
       $notify       = $_POST['notify'];
          
       include(FOLDER_PATH.'classes/class_users.inc.php');
          
       $MSP_USER = new user();
          
       if ($MSP_USER->field_check(0,100,$name))
       {
         $error_string[] = $msg_user10;
       }
       if ($MSP_USER->is_email_valid($email))
       {
         $error_string[] = $msg_user11;
       }
       if (!ctype_alnum($password))
       {
         $error_string[] = $msg_user21; 
       }
       if ($error_string)
       {
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         $MSP_USER->prefix     = $database['prefix'];
         $MSP_USER->name       = cleanData($name);
         $MSP_USER->email      = $email;
         $MSP_USER->pass       = $password;
         $MSP_USER->dept       = $dept;
         $MSP_USER->live       = $livesupport;
         $MSP_USER->type       = $mod;
         $MSP_USER->signature  = $signature;
         $MSP_USER->notify     = $notify;
               
         $MSP_USER->add_user();
               
         updated($msg_user12,
                 'index.php?cmd=users',
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }

     //-----------------------
     // SCRIPT ACTION
     // Load Edit Screen
     //-----------------------
     
     if (isset($_GET['action']) && $_GET['action']=="edit")
     {
       $id = strip_tags($_GET['id']);
          
       if (ctype_digit($id))
       {
         $EDIT_SCREEN = true;
       }
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Delete User
     //-----------------------
     
     if (isset($_GET['action']) && $_GET['action']=="delete")
     {
       $id = strip_tags($_GET['id']);
          
       // Main set up account cannot be deleted

       if (ctype_digit($id))
       {
         if ($id==1)
         {
           header("Location: index.php?cmd=users");
         }
         else
         {
           mysql_query("DELETE FROM ".$database['prefix']."users 
                        WHERE id = '$id' 
                        LIMIT 1
                        ") or die(mysql_error());

           updated($msg_user22,
                   'index.php?cmd=users',
                   $msg_script8,
                   $msg_script7,
                   $msg_charset
                   );
         }
       }
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Update User
     //-----------------------
     
     if (isset($_GET['form']) && $_GET['form']=="update")
     {
       $id           = $_POST['id'];
       $pass         = $_POST['pass'];
       $name         = trim($_POST['name']);
       $email        = $_POST['email'];
       $password     = trim($_POST['password']);
       $dept         = $_POST['dept'];
       $livesupport  = $_POST['livesupport'];
       $mod          = $_POST['mod'];
       $signature    = trim($_POST['signature']);
       $notify       = $_POST['notify'];
          
       include(FOLDER_PATH.'classes/class_users.inc.php');

       $MSP_USER = new user();
          
       if ($MSP_USER->field_check(0,100,$name))
       {
         $error_string[] = $msg_user10;
       }
       if ($MSP_USER->is_email_valid($email))
       {
         $error_string[] = $msg_user11;
       }
       if ($password && !ctype_alnum($password))
       {
         $error_string[] = $msg_user21; 
       }
       if ($error_string)
       {
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         $MSP_USER->prefix     = $database['prefix'];
         $MSP_USER->name       = cleanData($name);
         $MSP_USER->email      = $email;
         $MSP_USER->pass       = $password;
         $MSP_USER->pass2      = $pass;
         $MSP_USER->dept       = $dept;
         $MSP_USER->live       = $livesupport;
         $MSP_USER->type       = $mod;
         $MSP_USER->signature  = $signature;
         $MSP_USER->notify     = $notify;
         $MSP_USER->id         = $id;
               
         $MSP_USER->update_user();
               
         //------------------------------------------------------------------
         // If the user we are updating is the one logged in, check to see
         //  if password has been changed. If it has log them out
         //------------------------------------------------------------------

         if ($id==$MSP_SUPPORTTEAM->id && ($password))
         {
           session_unset();
           session_destroy();

           if (isset($cookie_data))
           {
             setcookie("support_cookie_email", "");
             setcookie("support_cookie_pass", "");
             unset($cookie_data);
           }

           if (isset($session_data))
           {
             unset ($_SESSION);
             unset($session_data);
           }

           updated($msg_user24,
                   'index.php?cmd=login',
                   $msg_script8,
                   $msg_script7,
                   $msg_charset
                   );
         }
         else
         {
           updated($msg_user24,
                   'index.php?cmd=users&amp;action=edit&amp;id='.$id,
                   $msg_script8,
                   $msg_script7,
                   $msg_charset
                   );
         }
       }
     }

     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/users.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;

     //--------------------
     // Case: Ban Filters
     // Added in v1.3
     //--------------------

     case "banfilters":

     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }

     //-----------------------
     // SCRIPT ACTION
     // Update Filters
     //-----------------------

     if (isset($_GET['form']) && $_GET['form']=="update")
     {
       $ips     = trim($_POST['ips']);
       $emails  = trim($_POST['emails']);
       $words   = trim($_POST['words']);

       include(FOLDER_PATH.'classes/class_banfilters.inc.php');

       $MSP_FILTERS          = new msBan();
       $MSP_FILTERS->ips     = $ips;
       $MSP_FILTERS->emails  = $emails;
       $MSP_FILTERS->words   = $words;
       
       $MSP_FILTERS->update_filters_sql($database['prefix']);

       updated($msg_banfilter7,
               'index.php?cmd=banfilters',
               $msg_script8,
               $msg_script7,
               $msg_charset
               );
     }

     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/banfilters.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;

     //====================
     // CASE: STATS
     //====================

     case "stats":

     $id = $_GET['id'];
     
     if (ctype_digit($id))
     {
       include(FOLDER_PATH.'data_files/popup/stats.php');
     }
     
     break;

     //====================
     // CASE: VIEWTICKET
     //====================

     case "viewticket":
     
     //-----------------------------------------------------------------------------------
     // Check to see if session or cookie data is present
     // If we have come straight to this page, admin has clicked link in e-mail
     // If session and cookie data are not active, we direct to log in page
     // First though, assign ticket id to session variable
     // This enables us to direct straight to the ticket page after log in
     // This was added in v1.2
     //-----------------------------------------------------------------------------------
     
     if (isset($_GET['id']) && !isset($session_data) && !isset($cookie_data))
     {
       $_SESSION['ticketID'] = $_GET['id'];
     }
     
     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Open/Close Ticket
     //-----------------------
     
     if (isset($_GET['action']) && ($_GET['action']=="open" || $_GET['action']=="close"))
     {
       $id = strip_tags($_GET['id']);
          
       if (ctype_digit($id))
       {
         mysql_query("UPDATE ".$database['prefix']."tickets SET 
                      status      = '".($_GET['action']=='open' ? 1 : 0)."',
                      ".($_GET['action']=='open' ? "permaClose = '0'," : "")."
                      filterdate  = '".date("Y-m-d")."'
                      WHERE id    = '$id' 
                      LIMIT 1
                      ") or die(mysql_error());

         updated(($_GET['action']=='open' ? $msg_viewticket16 : $msg_viewticket15),
                 'index.php?cmd=viewticket&amp;id='.$id,
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Change Priority
     //-----------------------
     
     if (isset($_GET['action']) && $_GET['action']=="priority")
     {
       $id        = $_POST['id'];
       $priority  = $_POST['priority'];
          
       mysql_query("UPDATE ".$database['prefix']."tickets SET 
                    priority  = '$priority' 
                    WHERE id  = '$id' 
                    LIMIT 1
                    ") or die(mysql_error());
          
       updated($msg_viewticket17,
               'index.php?cmd=viewticket&amp;id='.$id,
               $msg_script8,
               $msg_script7,
               $msg_charset
               );
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Change Department
     //-----------------------
     
     if (isset($_GET['action']) && $_GET['action']=="dept")
     {
       $id        = $_POST['id'];
       $dept      = $_POST['dept'];

       $q_dept = mysql_query("SELECT name FROM ".$database['prefix']."departments 
                              WHERE id = '$dept' 
                              LIMIT 1
                              ") or die(mysql_error());
       $DEPT = mysql_fetch_object($q_dept);
          
       mysql_query("UPDATE ".$database['prefix']."tickets SET 
                             department  = '".mysql_real_escape_string($DEPT->name)."',
                             deptid      = '$dept'
                             WHERE id    = '$id'
                             LIMIT 1
                             ") or die(mysql_error());
          
       //-----------------------------------------------------------------------------
       // If support member can`t access the new department, redirect to open page
       //-----------------------------------------------------------------------------

       if ($MSP_SUPPORTTEAM->department!='0' && $MSP_SUPPORTTEAM->department!=$DEPT->id)
       {
         updated($msg_viewticket18,
                 'index.php?cmd=open',
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
       else
       {
         updated($msg_viewticket18,
                 'index.php?cmd=viewticket&amp;id='.$id,
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Update E-Mail Address
     // Added in v1.2
     //-----------------------
     
     if (isset($_GET['action']) && $_GET['action']=="email")
     {
       $id         = $_POST['id'];
       $cur_email  = $_POST['cur_email'];
       $email      = trim($_POST['email']);
          
       mysql_query("UPDATE ".$database['prefix']."tickets SET 
                    email     = '".($email ? $email : $cur_email)."' 
                    WHERE id  = '$id' 
                    LIMIT 1
                    ") or die(mysql_error());

       updated($msg_viewticket34,
               'index.php?cmd=viewticket&amp;id='.$id,
               $msg_script8,
               $msg_script7,
               $msg_charset
               );
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Add Response
     //-----------------------

     if (isset($_POST['add']))
     {
       $id           = $_POST['id'];
       $livesupport  = $_POST['livesupport'];
       $name         = $_POST['name'];
       $ticketid     = $_POST['ticketid'];
       $subject      = $_POST['subject'];
       $dept         = $_POST['dept'];
       $priority     = $_POST['priority'];
       $email        = $_POST['email'];
       $answer       = trim($_POST['answer']);
       $close        = (isset($_POST['close']) ? 1 : 0);
       $perm         = (isset($_POST['perm']) ? 1 : 0);
       $attachment   = $_POST['attachment'];
       $merge        = (isset($_POST['merge']) ? 1 : 0);
       $sendmail     = (isset($_POST['sendmail']) ? 1 : 0);
       $admin_email  = $_POST['admin_email'];
       $admin_name   = $_POST['admin_name'];
       $ts           = $_POST['ts'];
       $merge_id     = (isset($_POST['merge_id']) ? strtoupper($_POST['merge_id']) : '');
       
       include(RELATIVE_PATH.'classes/class_ticket.inc.php');
          
       $MSP_TICKET          = new ticket();
       $MSP_TICKET->prefix  = $database['prefix'];
          
       if ($MSP_TICKET->field_check(0,0,$answer))
       {
         $error_string[] = $msg_viewticket19;
       }
       if ($merge_id)
       {
         if ($merge_id==$ticketid)
         {
           $error_string[] = $msg_viewticket42;
         }
         if (!$MSP_TICKET->getTicket($merge_id))
         {
             $error_string[] = str_replace("{ticketid}", $merge_id, $msg_viewticket41);
         }
       }
       if ($error_string)
       {
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         // If we merging ticket to another, get last response time for merge ticket
         
         $MSP_TICKET->id         = $id;
         $MSP_TICKET->date       = date($SETTINGS->dateformat, strtotime("".$SETTINGS->timeOffset." hours"));
         $MSP_TICKET->name       = $name;
         $MSP_TICKET->admin      = $admin_name;
         $MSP_TICKET->ticketid   = ($merge_id ? $merge_id : $ticketid);
         $MSP_TICKET->subject    = $subject;
         $MSP_TICKET->dept       = $dept;
         $MSP_TICKET->priority   = priorityLevel($priority);
         $MSP_TICKET->email      = $email;
         $MSP_TICKET->comments   = $answer;
         $MSP_TICKET->close      = $close;
         $MSP_TICKET->perm       = $perm;
         $MSP_TICKET->ts         = ($merge_id ? $MSP_TICKET->getMergeTicketTime($merge_id) : $ts);
         $MSP_TICKET->days       = $msg_script17;
         $MSP_TICKET->hours      = $msg_script18;
         $MSP_TICKET->mins       = $msg_script19;
         $MSP_TICKET->days2      = $msg_script20;
         $MSP_TICKET->hours2     = $msg_script21;
         $MSP_TICKET->mins2      = $msg_script22;
         $MSP_TICKET->month      = $msg_script24;
         $MSP_TICKET->signature  = ($MSP_SUPPORTTEAM->signature ? define_newline().define_newline().cleanData($MSP_SUPPORTTEAM->signature) : '');

         // If live support, send no mail
         // If ticket had been merged and merge notification is set,
         //  replace default update e-mail with merge e-mail
         // Updated in v1.3
         
         if ($merge_id)
         {
           $prev = $MSP_TICKET->getTicket($merge_id,true);
         }
         
         if ($sendmail)
         {
           $MSP_MAIL->addTag('{NAME}',$name);
           $MSP_MAIL->addTag('{FIRST_TICKET}',($merge_id ? $prev->subject : ''));
           $MSP_MAIL->addTag('{SECOND_TICKET}',$subject);
           $MSP_MAIL->addTag('{TICKET}',($merge_id ? $merge_id : $ticketid));
           $MSP_MAIL->addTag('{DATE}',date($SETTINGS->dateformat, strtotime("".$SETTINGS->timeOffset." hours")));
           $MSP_MAIL->addTag('{SUBJECT}',($merge_id ? $prev->subject : ($subject ? $subject : $msg_viewticket45)));
           $MSP_MAIL->addTag('{DEPT}',$dept);
           $MSP_MAIL->addTag('{PRIORITY}',priorityLevel($priority));
           $MSP_MAIL->addTag('{LINK}','index.php?e='.$email.'&t='.($merge_id ? $merge_id : $ticketid));
           
           $MSP_MAIL->sendMail($name,
                              $email,
                              $SETTINGS->website,
                              $MSP_SUPPORTTEAM->email,
                              '['.$SETTINGS->website.'] '.$msg_viewticket21.($merge_id ? $merge_id : $ticketid),
                              $MSP_MAIL->template(RELATIVE_PATH.'templates/email/'.($merge_id && $merge ? 'ticket_merged' : 'admin_response').'.txt')
                              );
         }

         // Assign bookmark variable..
         $bookmark = $MSP_TICKET->add_admin_reply();
         
         // If ticket was merged, delete this ticket
         // Also update attachment if one was present with new ticket..
         // Added in v1.3
         if ($merge_id)
         {
           $MSP_TICKET->mergeSupportTicket($ticketid,
                                           $merge_id,
                                           $attachment,
                                           ($merge_id ? $prev->attachfile : ''),
                                           $msg_viewticket44
                                           );
         }
               
         updated(($merge_id ? $msg_viewticket39 : $msg_viewticket20),
                 'index.php?cmd=viewticket&amp;id='.($merge_id ? $prev->id : $id.'#'.$bookmark),
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Delete Reply
     //-----------------------
     
     if (isset($_GET['action']) && $_GET['action']=="deletereply")
     {
       $id     = strip_tags($_GET['id']);
       $reply  = strip_tags($_GET['reply']);
          
       if (ctype_digit($id))
       {
         mysql_query("DELETE FROM ".$database['prefix']."replies 
                      WHERE id = '$reply' 
                      LIMIT 1
                      ") or die(mysql_error());
          
         updated($msg_viewticket25,
                 'index.php?cmd=viewticket&amp;id='.$id,
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Load Edit Reply Screen
     //-----------------------

     if (isset($_GET['action']) && $_GET['action']=="editreply")
     {
       $id     = strip_tags($_GET['id']);
       $reply  = strip_tags($_GET['reply']);
          
       if (ctype_digit($id))
       {
         $EDITSCREEN = true;
       }
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Update Reply
     //-----------------------
     
     if (isset($_POST['update']))
     {
       $id      = $_POST['id'];
       $reply   = $_POST['reply'];
       $answer  = $_POST['answer'];
       $close   = (isset($_POST['close']) ? 1 : 0);
          
       include(RELATIVE_PATH.'classes/class_ticket.inc.php');
          
       $MSP_TICKET = new ticket();
          
       if ($MSP_TICKET->field_check(0,0,$answer))
       {
         $error_string[] = $msg_viewticket19;
       }
       if ($error_string)
       {
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         $MSP_TICKET->prefix    = $database['prefix'];
         $MSP_TICKET->id        = $id;
         $MSP_TICKET->replyid   = $reply;
         $MSP_TICKET->comments  = $answer;
         $MSP_TICKET->close     = $close;
               
         $MSP_TICKET->update_reply();
               
         updated($msg_viewticket28,
                 'index.php?cmd=viewticket&amp;id='.$id.'#'.$id,
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }
     
     $id = (isset($_GET['id']) ? strip_tags($_GET['id']) : $_POST['id']);

     if ($id && ctype_digit($id))
     {
       $q_ticket = mysql_query("SELECT * FROM ".$database['prefix']."tickets 
                                WHERE id = '$id'
                                ") or die(mysql_error());
       $VIEW = mysql_fetch_object($q_ticket);
     }
     else
     {
       exit;
     }

     if ($MSP_SUPPORTTEAM->department!='0' && $MSP_SUPPORTTEAM->department!=$VIEW->deptid)
     {
       $error_string[] = $msg_script23;

       error($msg_script10,
             $msg_script9,
             $msg_charset,
             $error_string
             );
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Preview Ticket
     // Added in v1.3
     //-----------------------
     
     if (isset($_POST['preview']))
     {
       $answer = trim($_POST['answer']);
       
       if (isset($_GET['reply']))
       {
         $id     = strip_tags($_GET['id']);
         $reply  = strip_tags($_GET['reply']);

         if (ctype_digit($id))
         {
           $EDITSCREEN = true;
         }
       }
       
       if ($answer=='')
       {
         $error_string[] = $msg_viewticket19;

         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
     }

     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/viewticket.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;
     
     //===============
     // CASE: OPEN
     //===============

     case "open":
     
     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }
     
     $pr     = (isset($_GET['pr']) ? strip_tags($_GET['pr']) : 'all');
     $dept   = (isset($_GET['dept']) ? strip_tags($_GET['dept']) : 'all');
     
     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/open.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;

     //===============
     // CASE: CLOSE
     //===============

     case "close":
     
     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }
     
     $pr    = (isset($_GET['pr']) ? strip_tags($_GET['pr']) : 'all');
     $dept  = (isset($_GET['dept']) ? strip_tags($_GET['dept']) : 'all');
     
     //-----------------------
     // SCRIPT ACTION
     // Delete Tickets
     //-----------------------
     
     if (isset($_GET['action']) && $_GET['action']=="remove")
     {
       $ticket = (isset($_POST['ticket']) ? $_POST['ticket'] : '');
          
       if (empty($ticket))
       {
         $error_string[] = $msg_close5;
               
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         for ($i=0; $i<count($ticket); $i++)
         {
           $data = explode("##", $ticket[$i]);

           mysql_query("DELETE FROM ".$database['prefix']."tickets 
                        WHERE id = '".$data[0]."'
                        ") or die(mysql_error());
                        
           mysql_query("DELETE FROM ".$database['prefix']."replies 
                        WHERE ticketid = '".$data[1]."'
                        ") or die(mysql_error());
                    
           // Clear attachment if present
           
           if (isset($data[2]) && file_exists(RELATIVE_PATH.'images/attachments/'.$data[2]))
           {
             unlink(RELATIVE_PATH.'images/attachments/'.$data[2]);
           }

           unset($data);
         }
               
         updated($msg_close6,
                 'index.php?cmd=close',
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }

     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/close.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;
     
     //===============
     // CASE: SEARCH
     //===============

     case "search":
     
     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Search tickets
     //-----------------------
     
     if (isset($_GET['search']))
     {
       $keywords    = trim($_GET['keywords']);
       $dept        = $_GET['dept'];
       $priority    = $_GET['priority'];
       $status      = $_GET['status'];
       $from_day    = $_GET['from_day'];
       $from_month  = $_GET['from_month'];
       $from_year   = $_GET['from_year'];
       $to_day      = $_GET['to_day'];
       $to_month    = $_GET['to_month'];
       $to_year     = $_GET['to_year'];
          
       $from_date_string = '';
       $to_date_string   = '';

       if ($from_day && $from_month && $from_year)
       {
         $from_date_string = $from_year.'-'.$from_month.'-'.$from_day;
       }
       if ($to_day && $to_month && $to_year)
       {
         $to_date_string   = $to_year.'-'.$to_month.'-'.$to_day;
       }
          
       if ($keywords=="")
       {
         $error_string[] = $msg_search10;
               
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         // Build search query string..
               
         $search_words = explode(" ", $keywords);
               
         for ($i=0; $i<count($search_words); $i++)
         {
           if ($i)
           {
             $q_string .= " OR name LIKE '%".mysql_real_escape_string($search_words[$i])."%' OR subject LIKE '%".mysql_real_escape_string($search_words[$i])."%' OR comments LIKE '%".mysql_real_escape_string($search_words[$i])."%' OR ticketid = '".mysql_real_escape_string($search_words[$i])."'";
           }
           else
           {
             $q_string = "name LIKE '%".mysql_real_escape_string($search_words[$i])."%' OR subject LIKE '%".mysql_real_escape_string($search_words[$i])."%' OR comments LIKE '%".mysql_real_escape_string($search_words[$i])."%' OR ticketid = '".mysql_real_escape_string($search_words[$i])."' ";
           }
         }
               
         $sql_query_one = "WHERE (".$q_string.")";
               
         $sql_options = array();
               
         if ($dept!='no')
         {
           $sql_options[] = "AND deptid = '$dept'";
         }
         if ($priority!='no')
         {
           if ($priority=='live')
           {
             $sql_options[] = "AND livesupport = '1'";
           }
           else
           {
             $sql_options[] = "AND priority = '$priority'";
           }
         }
         if ($status!='no')
         {
           $sql_options[] = "AND status = '$status'";
         }
         if ($from_date_string && $to_date_string)
         {
           $sql_options[] = "AND filterdate BETWEEN '$from_date_string' AND '$to_date_string'";
         }

         $new_sql_string = '';
         $SQL            = '';

         if ($sql_options)
         {
           foreach ($sql_options as $data)
           {
             $new_sql_string .= ' '.$data.' ';
           }
                    
           $SQL =  $sql_query_one.$new_sql_string;
         }
         else
         {
           $SQL = $sql_query_one;
         }
         
         $q_count = mysql_query("SELECT count(*) AS s_count 
                                 FROM ".$database['prefix']."tickets 
                                 $SQL
                                 ") or die(mysql_error());
         $COUNT = mysql_fetch_object($q_count);
         
         $q_search = mysql_query("SELECT * 
                                  FROM ".$database['prefix']."tickets 
                                  $SQL 
                                  LIMIT $limitvalue,$limit
                                  ") or die(mysql_error());
               
         if (mysql_num_rows($q_search)>0)
         {
           $SEARCH         = true;
           $SEARCH_RESULTS = true;
         }
         else
         {
           $SEARCH         = true;
           $SEARCH_RESULTS = false;
         }
       }
     }

     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/search.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;
     
     //===============
     // CASE: KBASE
     //===============

     case "kbase":
     
     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }
     
     //----------------------
     // Check Permissions
     //----------------------
     
     if ($MSP_SUPPORTTEAM->admintype=='moder')
     {
       $error_string[] = $msg_script23;

       error($msg_script10,
             $msg_script9,
             $msg_charset,
             $error_string
             );
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Add Question
     //-----------------------
     
     if (isset($_GET['form']) && $_GET['form']=="add")
     {
       $question = strip_tags(trim($_POST['question']));
       $answer   = strip_tags(trim($_POST['answer']));
       $dept     = $_POST['dept'];

       include(FOLDER_PATH.'classes/class_kbase.inc.php');
          
       $MSP_KBASE = new knowledgeBase();
          
       if ($MSP_KBASE->field_check(0,0,$question))
       {
         $error_string[] = $msg_kbase6;
       }
       if ($MSP_KBASE->field_check(0,0,$answer))
       {
         $error_string[] = $msg_kbase7;
       }
       if ($error_string)
       {
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         $MSP_KBASE->prefix    = $database['prefix'];
         $MSP_KBASE->question  = $question;
         $MSP_KBASE->answer    = $answer;
         $MSP_KBASE->dept      = $dept;
               
         $MSP_KBASE->add_question();
               
         updated($msg_kbase8,
                 'index.php?cmd=kbase',
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Load Edit Window
     //-----------------------
     
     if (isset($_GET['action']) && $_GET['action']=="edit")
     {
       $id = strip_tags($_GET['id']);

       if (ctype_digit($id))
       {
         $EDIT_SCREEN = true;
       }
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Update Question
     //-----------------------
     
     if (isset($_GET['form']) && $_GET['form']=="update")
     {
       $id       = $_POST['id'];
       $question = strip_tags(trim($_POST['question']));
       $answer   = strip_tags(trim($_POST['answer']));
       $dept     = $_POST['dept'];
          
       include(FOLDER_PATH.'classes/class_kbase.inc.php');
          
       $MSP_KBASE = new knowledgeBase();
          
       if ($MSP_KBASE->field_check(0,0,$question))
       {
         $error_string[] = $msg_kbase6;
       }
       if ($MSP_KBASE->field_check(0,0,$answer))
       {
         $error_string[] = $msg_kbase7;
       }
       if ($error_string)
       {
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         $MSP_KBASE->prefix    = $database['prefix'];
         $MSP_KBASE->id        = $id;
         $MSP_KBASE->question  = $question;
         $MSP_KBASE->answer    = $answer;
         $MSP_KBASE->dept      = $dept;
               
         $MSP_KBASE->update_question();
               
         updated($msg_kbase15,
                 'index.php?cmd=kbase&amp;action=edit&amp;id='.$id,
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }
     
     //-----------------------
     // Hide/show form
     // Added in v1.3
     //-----------------------
     
     if (isset($_GET['expand']))
     {
       switch ($_GET['expand'])
       {
         case 1:
         setcookie("msp_kbase_expand", '31407b18c5a9dd810565caedda2d0e42', time()+60*60*24*30);
         break;
         
         case 0:
         setcookie("msp_kbase_expand", "");
         break;
       }
       
       header("Location: index.php?cmd=kbase");
       exit;
     }
     
     //-----------------------
     // SCRIPT ACTION
     // View Question
     //-----------------------
     
     if (isset($_GET['action']) && $_GET['action']=="view")
     {
       $id = strip_tags($_GET['id']);
          
       if (ctype_digit($id))
       {
         include(FOLDER_PATH.'data_files/popup/kbaseview.php');
       }
       
       exit;
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Delete Question
     //-----------------------
     
     if (isset($_GET['action']) && $_GET['action']=="delete")
     {
       $id = strip_tags($_GET['id']);
          
       if (ctype_digit($id))
       {
         mysql_query("DELETE FROM ".$database['prefix']."kbase 
                      WHERE id = '$id' 
                      LIMIT 1
                      ") or die(mysql_error());
          
         updated($msg_kbase11,
                 'index.php?cmd=kbase',
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }
     
     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/kbase.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;
     
     //===============
     // CASE: CONTACT
     //===============

     case "contact":
     
     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }
     
     //-----------------------
     // SCRIPT ACTION
     // Send Message
     //-----------------------
     
     if (isset($_GET['form']) && $_GET['form']=="send")
     {
       $user      = $_POST['user'];
       $subject   = trim($_POST['subject']);
       $comments  = trim($_POST['comments']);
       
       $s_team    = ($user!='none' ? explode("##", $user) : '');
          
       if (!is_array($s_team))
       {
         $error_string[] = $msg_contact6;
       }
       if ($subject=="")
       {
         $error_string[] = $msg_contact7;
       }
       if ($comments=="")
       {
         $error_string[] = $msg_contact8;
       }
       if ($error_string)
       {
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         $MSP_MAIL->sendMail($s_team[0],
                            $s_team[1],
                            $MSP_SUPPORTTEAM->name,
                            $MSP_SUPPORTTEAM->email,
                            $subject,
                            $comments
                            );

         updated($msg_contact9,
                 'index.php?cmd=contact',
                 $msg_script8,
                 $msg_script7,
                 $msg_charset
                 );
       }
     }

     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/contact.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;
     
     //===============
     // CASE: TOOLS
     // Added in v1.3
     //===============
     
     case 'tools':
     
     if (!isset($session_data) && !isset($cookie_data))
     {
       header("Location: index.php?cmd=login");
       exit;
     }
     
     //----------------------
     // Check Permissions
     //----------------------
     
     if ($MSP_SUPPORTTEAM->admintype!='admin')
     {
       $error_string[] = $msg_script23;

       error($msg_script10,
             $msg_script9,
             $msg_charset,
             $error_string
             );
     }
     
     if (isset($_POST['process']))
     {
       $ids = array();
       
       if (isset($_POST['process1']))
       {
         $days1  = trim($_POST['days1']);
         $dept   = $_POST['dept'];
         $clear  = isset($_POST['clear']) ? $_POST['clear'] : '';
         
         if ($days1!='' && ctype_digit($days1))
         {
           $date   = date("Y-m-d", strtotime("-$days1 days"));
           
           $SQL    = ($dept=='all' ? '' : (ctype_digit($dept) ? "AND deptid = '$dept'" : "AND livesupport = '1'")); 
           
           // Firstly clear replies and if specified attachments..
           $q_clear = mysql_query("SELECT * FROM ".$database['prefix']."tickets 
                                   WHERE filterdate < '$date'
                                   $SQL
                                   ") or die(mysql_error());
           
           while ($CLEAR = mysql_fetch_object($q_clear))
           {
             $ids[] = $CLEAR->id;
             
             // Clear attachments if specified and they exist..
             if ($clear)
             {
               if (file_exists(RELATIVE_PATH.'images/attachments/'.$CLEAR->attachfile))
               {
                 @unlink(RELATIVE_PATH.'images/attachments/'.$CLEAR->attachfile);
               }
             }
             
             // Clear ticket replies..
             mysql_query("DELETE FROM ".$database['prefix']."replies 
                          WHERE ticketid = '".$CLEAR->ticketid."'
                          ") or die(mysql_error());
           }
           
            // Finally, clear tickets..
           if (!empty($ids))
           {
            mysql_query("DELETE FROM ".$database['prefix']."tickets 
                         WHERE id IN(".implode(",",$ids).")
                         ") or die(mysql_error());
           }
           
           updated($msg_tools8,
                   'index.php?cmd=tools',
                   $msg_script8,
                   $msg_script7,
                   $msg_charset
                   );
         }
       }
       if (isset($_POST['process2']))
       {
         $days2  = trim($_POST['days2']);
         $dept   = $_POST['dept'];
         
         if ($days2!='' && ctype_digit($days2))
         {
           $date   = date("Y-m-d", strtotime("-$days2 days"));
           
           $SQL    = ($dept=='all' ? '' : (ctype_digit($dept) ? "AND deptid = '$dept'" : "AND livesupport = '1'")); 
           
           // Firstly clear replies and if specified attachments..
           $q_clear = mysql_query("SELECT * FROM ".$database['prefix']."tickets 
                                   WHERE filterdate < '$date'
                                   $SQL
                                   ") or die(mysql_error());
           
           while ($CLEAR = mysql_fetch_object($q_clear))
           {
             if (file_exists(RELATIVE_PATH.'images/attachments/'.$CLEAR->attachfile))
             {
               @unlink(RELATIVE_PATH.'images/attachments/'.$CLEAR->attachfile);
             }
           }
           
           updated($msg_tools8,
                   'index.php?cmd=tools',
                   $msg_script8,
                   $msg_script7,
                   $msg_charset
                   );
         }
       }
     }
     
     include(FOLDER_PATH.'inc/header.php');
     include(FOLDER_PATH.'data_files/tools.php');
     include(FOLDER_PATH.'inc/footer.php');
     break;

     //===============
     // CASE: LOGIN
     //===============

      case "login":
      
     //-------------------------------
     // Is session or cookie active?
     //-------------------------------

     if (isset($session_data) || isset($cookie_data))
     {
       header("Location: index.php");
       exit;
     }
      
     //-----------------------
     // SCRIPT ACTION
     // Login
     //-----------------------

     if (isset($_GET['form']) && $_GET['form']=="enter")
     {
       $email   = strip_tags(trim($_POST['email']));
       $pass    = strip_tags(trim($_POST['pass']));
       $cookie  = (isset($_POST['cookie']) ? 1 : 0);
          
       // Check valid e-mail address
          
       if (!eregi("^([a-z]|[0-9]|\.|-|_)+@([a-z]|[0-9]|\.|-|_)+\.([a-z]|[0-9]){2,4}$", $email))
       {
         $error_string[] = $msg_tplnewticket18;

         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }

       // Get admin login details

       $q_user = mysql_query("SELECT name,accpass 
                              FROM ".$database['prefix']."users 
                              WHERE email  = '$email' 
                              AND accpass  = '".md5($pass)."' 
                              LIMIT 1
                              ") or die(mysql_error());

       if (mysql_num_rows($q_user)==0)
       {
         $error_string[] = $msg_login4;
         
         error($msg_script10,
               $msg_script9,
               $msg_charset,
               $error_string
               );
       }
       else
       {
         $_SESSION['support_email'] = $email;
         $_SESSION['support_pass']  = $pass;

         if ($cookie)
         {
           setcookie("support_cookie_email", $email, time()+60*60*24*30);
           setcookie("support_cookie_pass", $pass, time()+60*60*24*30);
         }
       }
          
       // Ok, log in was successful.
       // Is ticket id present?
       // If so lets go to ticket if direct enabled

       if (isset($_SESSION['ticketID']) && ($_SESSION['ticketID'] && TICKET_REDIRECT))
       {
         header("Location: index.php?cmd=viewticket&id={$_SESSION['ticketID']}");
         exit;
       }
       else
       {
         header("Location: index.php");
       }
      }

      include(FOLDER_PATH.'inc/header.php');
      include(FOLDER_PATH.'data_files/login.php');
      include(FOLDER_PATH.'inc/footer.php');
      break;

      //===============
      // CASE: LOGOUT
      //===============

      case "logout":
      
      session_unset();
      session_destroy();

      if (isset($cookie_data))
      {
        setcookie("support_cookie_email", "");
        setcookie("support_cookie_pass", "");
        unset($cookie_data);
        unset($_COOKIE);
      }

      if (isset($session_data))
      {
        unset ($_SESSION);
        unset($session_data);
      }
      
      updated($msg_login,
              'index.php?cmd=login',
              $msg_script8,
              $msg_script7,
              $msg_charset
              );
      
      break;
      
      //================
      // CASE: PRINT
      // Added in v1.3
      //================
      
      case 'print':
      
      $id = strip_tags($_GET['id']);
      
      if (ctype_digit($id))
      {
        include(FOLDER_PATH.'data_files/popup/print.php');
      }
      
      break;

      //===============
      // CASE: SUPPORT
      //===============
      
      case 'support':
      include(FOLDER_PATH.'data_files/popup/support.php');
      break;
}

?>
