<?php

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  Script: Maian Support v1.3
  Written by: David Ian Bennett
  E-Mail: support@maianscriptworld.co.uk
  Website: http://www.maianscriptworld.co.uk

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
  This File: class_generic.inc.php
  Description: Generic Class

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


class genericOptions {

                      //======================================
                      // FUNCTION: FIELD_CHECK()
                      // Desc: Check if field data is valid
                      // Parameters: 3
                      //======================================

                      function field_check($num,$num2,$data)
                      {
                        if ($num2>0) {
                         if ($data=="" || $data=="0" || $data=="http://" || strlen($data)<$num || strlen($data)>$num2) {
                          return true;
                         } else {
                          return false;
                         }
                        }
                        else
                        {
                          if ($data=="" || $data=="http://" || $data=="0") {
                           return true;
                          } else {
                           return false;
                          }
                        }
                      }

                      
                      //======================================
                      // FUNCTION: IS_VALID_EMAIL()
                      // Desc: Check if e-mail field is valid
                      // Parameters: 1
                      //======================================
                      
                      function is_email_valid($email)
                      {
                        if (!eregi("^([a-z]|[0-9]|\.|-|_)+@([a-z]|[0-9]|\.|-|_)+\.([a-z]|[0-9]){2,4}$", $email)) {
                         return true;
                        } else {
                         return false;
                        }
                      }
                      
                      //====================================================================
                      // FUNCTION: RANDOM_DATA()
                      // Desc: Generates random alphanumeric string
                      // Parameters: 1
                      //====================================================================

                      function random_data($num)
                      {
                        $p = substr(md5(uniqid(rand(),1)), 3, $num);

                        return strtoupper($p);
                      }

                      //=============================================
                      // FUNCTION: STRIP_SLASHES()
                      // Desc: Strip slashes if magic quotes are on
                      // Parameters: 1
                      //=============================================
                      
                      function strip_slashes($data)
                      {
                        return (get_magic_quotes_gpc() ? stripslashes($data) : $data);
                      }
                      
                      //==============================================================
                      // FUNCTION: CHAR_ENTITIES()
                      // Desc: Converts certain chars to character entities
                      // Parameters: 1
                      //==============================================================
                      
                      function char_entities($data)
                      {
                        return htmlspecialchars($data);
                      }
                      
                      //======================================
                      // FUNCTION: ADD_SLASHES()
                      // Desc: Prevents SQL injection
                      // Parameters: 1
                      //======================================
                      
                      function add_slashes($data)
                      {
                        return mysql_real_escape_string($data);
                      }
                      
                      
                      //===============================
                      // FUNCTION: CONVERT_BBCODE()
                      // Convert BB Code to HTML
                      // Parameters: 1
                      //===============================

                      function convert_bbcode($data)
                      {
                        $data = eregi_replace(quotemeta("[b]"), quotemeta("<b>"), $data);
                        $data = eregi_replace(quotemeta("[/b]"), quotemeta("</b>"), $data);
                        $data = eregi_replace(quotemeta("[i]"), quotemeta("<i>"), $data);
                        $data = eregi_replace(quotemeta("[/i]"), quotemeta("</i>"), $data);
                        $data = eregi_replace(quotemeta("[u]"), quotemeta("<u>"), $data);
                        $data = eregi_replace(quotemeta("[/u]"), quotemeta("</u>"), $data);
                        $data = eregi_replace("\\[url=([^\\[]*)\\]([^\\[]*)\\[/url\\]", "<a href=\"\\1\" target=\"_blank\" title=\"\\1\"><u>\\2</u></a>", $data);
                        $data = eregi_replace("\\[email\\]([^\\[]*)\\[/email\\]", "<a href=\"mailto:\\1\" title=\"\\1\"><u>\\1</u></a>", $data);
                        
                        // Wrap text when returning from this function to prevent table stretching..
                        return wordwrap($data,60,"\n",1);
                      }
                      
                      //=========================================================
                      // FUNCTION: get_browser_type()
                      // Desc: Define the client's browser type
                      // Parameters: 0
                      //=========================================================

                      function get_browser_type()
                      {
                        $USER_BROWSER_AGENT = "";

                        if (ereg('OPERA(/| )([0-9].[0-9]{1,2})', strtoupper($_SERVER["HTTP_USER_AGENT"]), $log_version)) {
                         $USER_BROWSER_AGENT = 'OPERA';
                        } else if (ereg('MSIE ([0-9].[0-9]{1,2})',strtoupper($_SERVER["HTTP_USER_AGENT"]), $log_version)) {
                         $USER_BROWSER_AGENT = 'IE';
                        } else if (ereg('OMNIWEB/([0-9].[0-9]{1,2})', strtoupper($_SERVER["HTTP_USER_AGENT"]), $log_version)) {
                         $USER_BROWSER_AGENT = 'OMNIWEB';
                        } else if (ereg('MOZILLA/([0-9].[0-9]{1,2})', strtoupper($_SERVER["HTTP_USER_AGENT"]), $log_version)) {
                         $USER_BROWSER_AGENT = 'MOZILLA';
                        } else if (ereg('KONQUEROR/([0-9].[0-9]{1,2})', strtoupper($_SERVER["HTTP_USER_AGENT"]), $log_version)) {
                         $USER_BROWSER_AGENT = 'KONQUEROR';
                        } else {
                         $USER_BROWSER_AGENT = 'OTHER';
                        }

                        return $USER_BROWSER_AGENT;
                      }
                                      
                      //=========================================================
                      // FUNCTION: get_mime_type()
                      // Desc: Define MIME-TYPE according to target Browser.
                      // Parameters: 0
                      //=========================================================

                      function get_mime_type()
                      {
                        $USER_BROWSER_AGENT = $this->get_browser_type();

                        $mime_type = ($USER_BROWSER_AGENT == 'IE' || $USER_BROWSER_AGENT == 'OPERA')
                        ? 'application/octetstream'
                        : 'application/octet-stream';

                        return $mime_type;
                      }
}

?>
