CREATE TABLE ms_settings (
  id               int(5) NOT NULL auto_increment,
  website          varchar(150) NOT NULL default '',
  email            varchar(250) not null default '',
  script_path      varchar(250) not null default '',
  language         varchar(25) NOT NULL default 'english.php',
  dateformat       varchar(20) NOT NULL default 'D j M Y, G:ia',
  exampledate      timestamp,
  kbase            enum('0','1') NOT NULL default '0',
  attachment       enum('0','1') NOT NULL default '0',
  auto_zip         enum('0','1') NOT NULL default '0',
  filetypes        text not null default '',
  maxsize          int(10) NOT NULL default '200',
  enablelive       enum('0','1') NOT NULL default '0',
  liverefresh      tinyint(2) NOT NULL default '2',
  timeout          tinyint(2) NOT NULL default '2',
  enCaptcha        enum('0','1') NOT NULL default '1',
  enLiveCaptcha    enum('0','1') NOT NULL default '1',
  timeOffset       varchar(3) NOT NULL default '0',
  autoClose        int(5) not null default '0',
  banFilters       enum('0','1') not null default '0',
  smtp             enum('0','1') not null default '0',
  smtp_host        varchar(100) NOT NULL default 'localhost',
  smtp_user        varchar(100) NOT NULL default '',
  smtp_pass        varchar(100) NOT NULL default '',
  smtp_port        varchar(100) NOT NULL default '25',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

INSERT INTO ms_settings (id,website,email,script_path,language,dateformat,exampledate,kbase,attachment,auto_zip,filetypes,maxsize,enablelive,liverefresh,timeout,enCaptcha,enLiveCaptcha,timeOffset,autoClose,banFilters,smtp,smtp_host,smtp_user,smtp_pass,smtp_port) VALUES (1,'Your Website','reply@yoursite.com','http://www.yoursite.com/support','english.php','D j M Y, G:ia',now(),0,0,0,'','200','0','2','6','1','1','0','0','0','0','localhost','','','25');

CREATE TABLE ms_departments (
  id               int(5) NOT NULL auto_increment,
  name             varchar(100) NOT NULL default '',
  unique (name),
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE ms_users (
  id               int(5) NOT NULL auto_increment,
  name             varchar(100) NOT NULL default '',
  email            varchar(250) NOT NULL default '',
  accpass          varchar(32) NOT NULL default '',
  department       int(3) NOT NULL default '0',
  admintype        char(5) NOT NULL default '',
  livesupport      enum('0','1') not null default '0',
  signature        text not null default '',
  notify           enum('0','1') not null default '0',
  date             date,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

INSERT INTO ms_users (id,name,email,accpass,department,admintype,livesupport,notify,date) VALUES (1,'Your Name','you@yoursite.com','21232f297a57a5a743894a0e4a801fc3','0','admin','0','1',now());

CREATE TABLE ms_kbase (
  id               int(5) NOT NULL auto_increment,
  question         text not null default '',
  answer           text not null default '',
  department       int(3) NOT NULL default '0',
  adddate          timestamp,
  filterdate       date,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE ms_tickets (
  id               int(5) NOT NULL auto_increment,
  ticketid         char(6) NOT NULL default '',
  department       varchar(100) NOT NULL default '',
  deptid           int(3) NOT NULL default '0',
  name             varchar(150) NOT NULL default '',
  email            varchar(250) NOT NULL default '',
  subject          varchar(200) NOT NULL default '',
  comments         text not null default '',
  priority         enum('1','2','3') NOT NULL default '1',
  attachstatus     enum('0','1') NOT NULL default '0',
  attachfile       varchar(200) NOT NULL default '',
  ticketdate       datetime,
  postdate         varchar(30) NOT NULL default '',
  responder        enum('0','1') NOT NULL default '0',
  filterdate       date,
  status           enum('0','1') NOT NULL default '0',
  permaClose       enum('0','1') NOT NULL default '0',
  created          enum('0','1') NOT NULL default '0',
  ip               varchar(20) NOT NULL default '',
  livesupport      enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE ms_replies (
  id               int(5) NOT NULL auto_increment,
  ticketid         char(6) NOT NULL default '',
  name             varchar(150) NOT NULL default '',
  comments         text not null default '',
  posttime         datetime,
  postdate         varchar(30) NOT NULL default '',
  responsetime     varchar(75) NOT NULL default '',
  adminreply       enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE ms_banfilters (
  id         INT(5) NOT NULL auto_increment,
  ipaddress  MEDIUMTEXT NOT NULL default '',
  emails     MEDIUMTEXT NOT NULL default '',
  words      MEDIUMTEXT NOT NULL default '',
PRIMARY KEY(id)) TYPE=MyISAM;

INSERT INTO ms_banfilters VALUES (1,'','','viagra,medical,pills');
