<?php

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  Script: Maian Support v1.3
  Written by: David Ian Bennett
  E-Mail: support@maianscriptworld.co.uk
  Website: http://www.maianscriptworld.co.uk

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
  This File: functions.php
  Description: Program Functions

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

//=======================================
// FUNCTION: buildKnowledgeBase()
// Builds knowledge base data
// Added in v1.3
//=======================================

function buildKnowledgeBase()
{
  global $database,$msg_user18,$msg_tplkbase;
  $kbase_string   = '';
  $kbase_string2  = '';
  
  // Load template file into string..
  $template_file = file_get_contents('templates/data_tables/knowledge_base_divs.tpl');
  
  // Get data, assign to string..
  $query = mysql_query("SELECT * FROM ".$database['prefix']."departments ORDER BY name") or die(mysql_error());
  
  while ($DPT = mysql_fetch_object($query))
  {
    $q_kbase = mysql_query("SELECT * FROM ".$database['prefix']."kbase 
                            WHERE department = '$DPT->id' ORDER BY question") or die(mysql_error());
    
    $questions    = '';
    
    if (mysql_num_rows($q_kbase)>0)
    {
      while ($KB = mysql_fetch_object($q_kbase))
      {
        $questions .= '- <a href="index.php?kbase='.$KB->id.'" title="'.$msg_tplkbase.'" rel="gb_page_center['.KBASE_WINDOW.']">'.cleanData($KB->question).'</a><br>';
      }
    }
    
    $find     = array('{tpl_department}','{tpl_questions}');
    $replace  = array('<span title="'.cleanData($DPT->name).'">'.cleanData($DPT->name).'</span>',$questions);
    
    $kbase_string .= (mysql_num_rows($q_kbase)>0 ? str_replace($find,$replace,$template_file) : '');
  }
  
  // Is there data assign to all departments?
  $q_kbase2 = mysql_query("SELECT * FROM ".$database['prefix']."kbase 
                          WHERE department = '0' ORDER BY question") or die(mysql_error());
  
  $questions2    = '';
    
  if (mysql_num_rows($q_kbase2)>0)
  {
    while ($KB = mysql_fetch_object($q_kbase2))
    {
      $questions2 .= '- <a href="index.php?kbase='.$KB->id.'" title="'.$msg_tplkbase.'" rel="gb_page_center['.KBASE_WINDOW.']">'.cleanData($KB->question).'</a><br>';
    }
    
    $find     = array('{tpl_department}','{tpl_questions}');
    $replace  = array('<span title="'.$msg_user18.'">'.$msg_user18.'</span>',$questions2);
    
    $kbase_string2 .= (mysql_num_rows($q_kbase2)>0 ? str_replace($find,$replace,$template_file) : '');
  }
  
  return $kbase_string.($kbase_string2 ? $kbase_string2 : '');
}

//=======================================
// FUNCTION: priorityLevel()
// Gets priority level
// Added in v1.3
//=======================================

function priorityLevel($level)
{
  global $msg_tplnewticket9,$msg_tplnewticket10,$msg_tplnewticket11;
  
  switch ($level)
  {
    case 1:
    return $msg_tplnewticket9;
    break;

    case 2:
    return $msg_tplnewticket10;
    break;

    case 3:
    return $msg_tplnewticket11;
    break;
  }
}

//=======================================
// FUNCTION: deptName()
// Get department name
// Added in v1.3
//=======================================

function deptName($id)
{
  global $database;
  
  $q_dept = mysql_query("SELECT name FROM ".$database['prefix']."departments WHERE id = '$id' LIMIT 1") or die(mysql_error());
  $DEPT = mysql_fetch_object($q_dept);
  
  return cleanData($DEPT->name);
}

//=======================================
// FUNCTION: msg()
// Show message from ticket submission
// Added in v1.3
//=======================================

function msg($data=array(),$area='error',$email='',$ticket='')
{
  global $msg_tplnewticket23,$msg_tplnewticket29,
         $msg_tplnewticket30,$msg_tplshowticket7,$msg_tplshowticket8;
  $find     = array('{email}','{ticket}');
  $replace  = array($email,$ticket);
  
  switch ($area)
  {
    case 'error':
    
    $string = '<b>'.$msg_tplnewticket29.'</b><br><br>';
    
    foreach ($data AS $error)
    {
      $string .= '&#8226; '.$error."<br>\n"; 
    }
    
    return $string;
    break;
    
    case 'ok':
    return '<b>'.$msg_tplnewticket23.'</b><br><br>'.str_replace($find,$replace,$msg_tplnewticket30);
    break;
    
    case 'response':
    return '<b>'.$msg_tplshowticket8.'</b><br><br>'.$msg_tplshowticket7;
    break;
  }
}

//===========================================
// FUNCTION: attachmentDisplayMessage()
// Attachment display message
// Added in v1.3
//===========================================

function attachmentDisplayMessage()
{
  global $SETTINGS,$msg_javascript22,$msg_javascript25;
  
  if ($SETTINGS->maxsize || $SETTINGS->filetypes)
  {
    return $msg_javascript22;
  }
  else
  {
    return $msg_javascript25;
  }
}

//=====================================
// FUNCTION: getAttachmentFileSize()
// Gets file size of attachment
//=====================================

function getAttachmentFileSize($file)
{
  $new_size = '';
  $filesize = 0;

  if (file_exists(FOLDER_PATH.'images/attachments/'.$file))
  {
    $filesize = filesize(FOLDER_PATH.'images/attachments/'.$file);
  }

  if ($filesize > 1023987)
  {
    $new_size = '<b>'.number_format(($filesize/1048576),1).'</b> MB';
  }
  else if ($filesize < 1024)
  {
    $new_size = '<b>'.$filesize.'</b> '.$msg_viewticket43;
  }
  else
  {
    $new_size = '<b>'.number_format(($filesize/1024),2).'</b> KB';
  }
  
  return $new_size;
}

//========================
// FUNCTION: maxSize()
// Get max file size
// Added in v1.3
//========================

function maxSize()
{
  global $SETTINGS;
  
  if ($SETTINGS->maxsize)
  {
    if ($SETTINGS->maxsize < 1024)
    {
      return '<br>'.$SETTINGS->maxsize.'KB';
    }
    if ($SETTINGS->maxsize > 1024)
    {
      return '<br>'.number_format($SETTINGS->maxsize/1024,0).'MB';
    }
  }
}

//=================================
// Function: ban_filter_check()
// Ban filter check
// Added in v1.3
//=================================

function ban_filter_check($type,$input)
{
  global $database,$SETTINGS;

  $input = strtolower($input);

  $q_ban = mysql_query("SELECT $type FROM ".$database['prefix']."banfilters LIMIT 1") or die(mysql_error());
  $FILTER = mysql_fetch_row($q_ban);

  $data = explode(",", trim($FILTER[0]));

  if (!empty($input) && $SETTINGS->banFilters && trim($FILTER[0])!='')
  {
    switch ($type)
    {
      case 'ipaddress':

      while (list($key,$value) = each($data))
      {
        $value = strtolower(trim($value));

        if ($value === $input)
        {
          $match = true;
        }

        if (substr($value,0,1)=='*')
        {
          $new_value = str_replace("*", "", $value);

          if (strstr($input,$new_value))
          {
            $match = true;
          }

          unset($new_value);
        }
      }

      break;

      case 'emails':

      while (list($key,$value) = each($data))
      {
        $value = strtolower(trim($value));

        if ($value === $input)
        {
          $match = true;
        }

        if (substr($value,0,1)=='*')
        {
          $new_value = str_replace(array("*","@"), "", $value);
          $e         = explode("@", $input);

          if (strstr($new_value,'.'))
          {
            if ($e[1] === $new_value)
            {
              $match = true;
            }
          }
          else
          {
            if (strstr($e[1],$new_value))
            {
              $match = true;
            }
          }

          unset($new_value);
        }
      }

      break;

      case 'words':

      while (list($key,$value) = each($data))
      {
        $value = strtolower(trim($value));

        if (strstr($input,$value))
        {
          $match = true;
        }

        if (substr($value,0,1)=='*')
        {
          $new_value = str_replace("*", "", $value);

          if (strstr($input,$new_value))
          {
            $match = true;
          }

          unset($new_value);
        }
      }

      break;
    }

    return isset($match) ? true : false;
  }
  else
  {
    return false;
  }
}

//=======================
// REDIRECT - CLEANDATA
// Added:v3.2
//=======================

function cleanData($data)
{
  return (get_magic_quotes_gpc() ? stripslashes($data) : $data);
}

//========================
// Clean evil tags
// Added in v1.3
//========================

function cleanEvilTags($data,$striptags=false)
{
  $data = preg_replace("/javascript/i", "j&#097;v&#097;script",$data);
  $data = preg_replace("/alert/i", "&#097;lert",$data);
  $data = preg_replace("/about:/i", "&#097;bout:",$data);
  $data = preg_replace("/onmouseover/i", "&#111;nmouseover",$data);
  $data = preg_replace("/onclick/i", "&#111;nclick",$data);
  $data = preg_replace("/onload/i", "&#111;nload",$data);
  $data = preg_replace("/onsubmit/i", "&#111;nsubmit",$data);
  $data = preg_replace("/<body/i", "&lt;body",$data);
  $data = preg_replace("/<html/i", "&lt;html",$data);
  $data = preg_replace("/document\./i", "&#100;ocument.",$data);

  return ($striptags ? strip_tags(trim($data)) : trim($data));
}

//================================
// DEFINE NEW LINE CHARACTER
// Added in v1.3
//================================

function define_newline()
{
  $unewline = "\r\n";

  if (strstr(strtolower($_SERVER["HTTP_USER_AGENT"]), 'win'))
  {
    $unewline = "\r\n";
  }
  else if (strstr(strtolower($_SERVER["HTTP_USER_AGENT"]), 'mac'))
  {
    $unewline = "\r";
  }
  else
  {
    $unewline = "\n";
  }

  return $unewline;
}

?>
