<?php

 /*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  Script: Maian Support v1.3
  Written by: David Ian Bennett
  E-Mail: support@maianscriptworld.co.uk
  Website: http://www.maianscriptworld.co.uk

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  This File: index.php
  Description: Main ticket interface

  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

 error_reporting(E_ALL ^ E_NOTICE);
 set_magic_quotes_runtime(0);

 define ('FOLDER_PATH', dirname(__FILE__).'/');
 include(FOLDER_PATH.'inc/db_connection.inc.php');
 include(FOLDER_PATH.'inc/functions.php');
 include(FOLDER_PATH.'lib/Savant2.php');
 include(FOLDER_PATH.'classes/class_mail.inc.php');
 include(FOLDER_PATH.'classes/class_ticket.inc.php');
 include(FOLDER_PATH.'classes/php-captcha.inc.php');

 //-------------------------------------------
 // Define vars
 // Create ticket class instance
 // Load settings/language file
 //-------------------------------------------

 define('INCLUDE_FILES', 1);
 define('KBASE_WINDOW', '500,300');
 $cmd         = (isset($_GET['cmd']) ? strip_tags($_GET['cmd']) : 'home');
 $SETTINGS    = mysql_fetch_object(mysql_query("SELECT * FROM ".$database['prefix']."settings LIMIT 1")) or die(mysql_error());
 include(FOLDER_PATH.'lang/'.$SETTINGS->language);
 
 $MSP_TICKET          = new ticket();
 $MSP_TICKET->prefix  = $database['prefix'];
 
 //-----------------------------------------------------
 // Create mail class and pass default mail variables
 //-----------------------------------------------------

 $MSP_MAIL             = new mailClass();
 $MSP_MAIL->smtp       = $SETTINGS->smtp;
 $MSP_MAIL->smtp_host  = $SETTINGS->smtp_host;
 $MSP_MAIL->smtp_user  = $SETTINGS->smtp_user;
 $MSP_MAIL->smtp_pass  = $SETTINGS->smtp_pass;
 $MSP_MAIL->smtp_port  = $SETTINGS->smtp_port;
 $MSP_MAIL->addTag('{SCRIPT_PATH}', $SETTINGS->script_path);
 $MSP_MAIL->addTag('{WEBSITE_NAME}', $SETTINGS->website);
 $MSP_MAIL->addTag('{WEBSITE_URL}', 'http://'.$_SERVER['HTTP_HOST']);
 
 $error_string = array();

 switch ($cmd)
 {
   case "home":
      
  $e = (isset($_GET['e']) ? strip_tags($_GET['e']) : '');
  $t = (isset($_GET['t']) ? strip_tags($_GET['t']) : '');
      
  // Show ticket..
  if (isset($_POST['show_ticket']))
  {
    $ticket  = trim($_POST['ticket']);
    $email   = trim($_POST['email']);
    
    if ($ticket!='' || $email!='')
    {
      if (!ctype_alnum($ticket) || strlen($ticket)!=6)
      {
        $t_error = $msg_tplmain12;
      }
      if ($email && !eregi("^([a-z]|[0-9]|\.|-|_)+@([a-z]|[0-9]|\.|-|_)+\.([a-z]|[0-9]){2,4}$", $email))
      {
        $e_error = $msg_tplmain13;
      }
      if (!isset($t_error) && !isset($e_error))
      {
        if (!$MSP_TICKET->isSupportTicket($ticket,$email))
        {
          $t_error = $msg_tplmain14;
        }
        else
        {
          header("Location: index.php?cmd=showticket&e=".$email."&t=".$ticket);
          exit;
        }
      }
    }
    else
    {
      header("Location: index.php");
    }
  }
  
  // Redirect to new ticket page..
  if (isset($_POST['create']))
  {
    header("Location: index.php?cmd=ticket");
    exit;
  }
  
  // Is the knowledge base enabled?
  if ($SETTINGS->kbase)
  {
    $kbData = buildKnowledgeBase();
  }
  else
  {
    $kbData = '<img class="messageImage" src="images/kbase_folder.gif" alt="'.$msg_tplmain11.'" title="'.$msg_tplmain11.'"><br><br>'.$msg_tplmain15;
  }
  
  // Show knowledge base info in pop up..
  // Added in v1.3
  if (isset($_GET['kbase']))
  {
    $id = strip_tags($_GET['kbase']);
    
    if (ctype_digit($id))
    {
      $q_kb = mysql_query("SELECT *,UNIX_TIMESTAMP(adddate) as a_date 
                           FROM ".$database['prefix']."kbase 
                           WHERE id = '$id' 
                           LIMIT 1
                           ") or die(mysql_error());
      $KBASE = mysql_fetch_object($q_kb);
      
      $tpl_kbase =& new Savant2();
      $tpl_kbase->assign('CHARSET', $msg_charset);
      $tpl_kbase->assign('QUESTION', $MSP_TICKET->convert_bbcode(nl2br(cleanData($KBASE->question))));
      $tpl_kbase->assign('ANSWER', $MSP_TICKET->convert_bbcode(nl2br(cleanData($KBASE->answer))));
      $tpl_kbase->assign('LAST_UPDATED', $msg_tplkbasewindow);
      $tpl_kbase->assign('DATE', date($SETTINGS->dateformat,$KBASE->a_date));
      $tpl_kbase->display('templates/knowledge_base_window.tpl.php');
    }
    
    exit;
  }
      
  include(FOLDER_PATH.'inc/header.php');

  $tpl_home =& new Savant2();
  $tpl_home->assign('TABLEMESSAGE', $msg_tplmain);
  $tpl_home->assign('MESSAGE', $msg_tplmain2);
  $tpl_home->assign('CURMESSAGE', $msg_tplmain3);
  $tpl_home->assign('CURTICKETMESSAGE', $msg_tplmain4);
  $tpl_home->assign('TICKETID', $msg_tplmain5);
  $tpl_home->assign('TICKETEMAIL', $msg_tplmain6);
  $tpl_home->assign('TICKETVALUE', $t);
  $tpl_home->assign('EMAILVALUE', $e);
  $tpl_home->assign('TICKETSHOW', $msg_tplmain7);
  $tpl_home->assign('NEWMESSAGE', $msg_tplmain8);
  $tpl_home->assign('NEWTICKETMESSAGE', $msg_tplmain9);
  $tpl_home->assign('TICKETOPEN', $msg_tplmain10);
  $tpl_home->assign('KBASE', $msg_tplmain11);
  $tpl_home->assign('KBASE_DATA', (isset($kbData) ? $kbData : ''));
  $tpl_home->assign('TICKET_ERROR', (isset($t_error) ? '<br><span class="error">'.$t_error.'</span>' : (isset($_GET['noticket']) ? '<br><span class="error">'.$msg_tplmain14.'</span>' : '')));
  $tpl_home->assign('EMAIL_ERROR', (isset($e_error) ? '<br><span class="error">'.$e_error.'</span>' : ''));
  $tpl_home->display('templates/main.tpl.php');
      
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  case "ticket":

  //-----------------------
  // SCRIPT ACTION
  // Create Ticket
  //-----------------------
      
  if (isset($_POST['create']))
  {
    $dept        = (isset($_POST['dept']) ? $_POST['dept'] : '');
    $name        = cleanEvilTags($_POST['name'],true);
    $email       = $_POST['email'];
    $subject     = cleanEvilTags($_POST['subject'],true);
    $comments    = cleanEvilTags($_POST['comments']);
    $priority    = $_POST['priority'];
    $code        = (isset($_POST['code']) ? trim($_POST['code']) : '');
    
    // Are attachments enabled?
    // To prevent problems with file name with spaces or other chars, rename..
    if ($SETTINGS->attachment)
    {
      if ($_FILES['attachment']['name']!='')
      { 
        $file_name  = $MSP_TICKET->renameAttachmentFile($_FILES['attachment']['name']);
        $file_temp  = $_FILES['attachment']['tmp_name'];
        $file_size  = $_FILES['attachment']['size'];
      }
    } 
    
    $MSP_TICKET->attachment  = (isset($file_name) ? $file_name : '');
    $MSP_TICKET->filesize    = (isset($file_size) ? $file_size : 0);
    $MSP_TICKET->maxsize     = $SETTINGS->maxsize;
    $MSP_TICKET->filetypes   = $SETTINGS->filetypes;
    $MSP_TICKET->attstatus   = (isset($file_name) ? 1 : 0);
    
    if (ban_filter_check('ipaddress',$_SERVER['REMOTE_ADDR']))
    {
      $error_string[] = $msg_tplnewticket31;
    }
    else
    {
      if ($MSP_TICKET->field_check(0,0,$name))
      {
        $error_string[] = $msg_tplnewticket17;
      }
      if ($MSP_TICKET->is_email_valid($email))
      {
        $error_string[] = $msg_tplnewticket18;
        $e_check        = true;
      }
      if (!isset($e_check) && ban_filter_check('emails',$email))
      {
        $error_string[] = $msg_tplnewticket32;
      }
      if ($MSP_TICKET->field_check(0,200,$subject))
      {
        $error_string[] = $msg_tplnewticket19;
      }
      if ($MSP_TICKET->field_check(0,0,$comments))
      {
        $error_string[] = $msg_tplnewticket20;
        $c_check        = true;
      }
      if (!isset($c_check) && ban_filter_check('words',$comments))
      {
        $error_string[] = $msg_tplnewticket33;
      }
      if (isset($file_name) && (isset($file_temp) && $file_temp))
      {
        if (!$MSP_TICKET->check_file_size() && $SETTINGS->maxsize)
        {
          $error_string[] = $msg_tplnewticket21;
          $a_error        = true;
        }
        if (!$MSP_TICKET->check_type() && $SETTINGS->filetypes)
        {
          $error_string[] = $msg_tplnewticket22;
          $a_error        = true;
        }
        if (isset($a_error))
        {
          if (file_exists($file_temp))
          {
            @unlink($file_temp);
          }
        }
      }
      if ($SETTINGS->enCaptcha)
      {
        if (!PhpCaptcha::Validate($code))
        {
          $error_string[] = $msg_tplnewticket28;
        }
      }
    }
    if (!empty($error_string))
    {
      $ERRORS  = new mailClass();
      $ERRORS->addTag('{tpl_display_message}','<span class="error">'.msg($error_string).'</span>');
      $ERRORS->addTag('{tpl_display_image}','<img class="messageImage" src="images/error.gif" alt="'.$msg_script9.'" title="'.$msg_script9.'">');
      $ticketMsg = $ERRORS->template('templates/data_tables/message_table.tpl');
      $ERRORS->clearVars();
    }
    else
    {
      // Generate new ticket number..
      $new_ticket             = $MSP_TICKET->ticket_id();
      
      // Generate zip file attachment name..
      $zip_file               = rand(11,99).time().'_attach.zip';
      
      $MSP_TICKET->dept       = deptName($dept);
      $MSP_TICKET->deptid     = $dept;
      $MSP_TICKET->name       = $name;
      $MSP_TICKET->email      = $email;
      $MSP_TICKET->subject    = $subject;
      $MSP_TICKET->comments   = $comments;
      $MSP_TICKET->priority   = priorityLevel($priority);
      $MSP_TICKET->priority2  = $priority;
      $MSP_TICKET->date       = date($SETTINGS->dateformat, strtotime("".$SETTINGS->timeOffset." hours"));
      $MSP_TICKET->ticketid   = $new_ticket;
      $MSP_TICKET->zipfile    = (isset($file_name) ? ($SETTINGS->auto_zip ? $zip_file : $file_name) : '');
      $MSP_TICKET->temp       = (isset($file_temp) ? $file_temp : '');

      // If an attachment is present, upload it..
      if (isset($file_name))
      {
        $MSP_TICKET->upload_file();
      }

      // If auto zipping is enabled, zip file..
      if (isset($file_name) && $SETTINGS->auto_zip)
      {
        include(FOLDER_PATH.'classes/class_zipcompression.inc.php');

        $MSP_ZIP = new createZip();

        if (file_exists('images/attachments/'.$file_name))
        {
          $MSP_ZIP->AddDirectory($new_ticket.'_attachment/');

          $getContents = file_get_contents('images/attachments/'.$file_name);

          $MSP_ZIP->addFile($getContents, $new_ticket.'_attachment/'.$file_name);

          $ZIPFILENAME  = 'images/attachments/'.$zip_file;
          $fd           = fopen ($ZIPFILENAME, "wb");
          $out          = fwrite ($fd, $MSP_ZIP->getZippedfile());
          fclose ($fd);
                          
          @unlink('images/attachments/'.$file_name);     
        }
      }
      
      // Add to database. Assign lates id to variable..
      $id                    = $MSP_TICKET->new_ticket_sql();
      $MSP_TICKET->insertID  = $id;
      
      // Build mail tags..
      $MSP_MAIL->addTag('{NAME}', $name);
      $MSP_MAIL->addTag('{DATE}', date($SETTINGS->dateformat, strtotime("".$SETTINGS->timeOffset." hours")));
      $MSP_MAIL->addTag('{TICKET}', $new_ticket);
      $MSP_MAIL->addTag('{SUBJECT}', $subject);
      $MSP_MAIL->addTag('{DEPT}', deptName($dept));
      $MSP_MAIL->addTag('{PRIORITY}', priorityLevel($priority));
      $MSP_MAIL->addTag('{STATUS}', $msg_viewticket11);
      $MSP_MAIL->addTag('{ATTACHMENT}', (isset($file_name) && $file_name ? $msg_script5 : $msg_script6));
      $MSP_MAIL->addTag('{LINK}', 'index.php?cmd=showticket&e='.$email.'&t='.$new_ticket);
      $MSP_MAIL->addTag('{ADMINLINK}', 'index.php?cmd=viewticket&id='.$id);
      $MSP_MAIL->addTag('{COMMENTS}', $comments);
      
      // Send message to support team..
      $q_webmasters = mysql_query("SELECT * FROM ".$database['prefix']."users 
                                   WHERE department  = '$dept' 
                                   OR department     = '0'
                                   ") or die(mysql_error());
                                   
      while ($USERS = mysql_fetch_object($q_webmasters))
      {
        if ($USERS->notify)
        {                            
          $MSP_MAIL->sendMail($USERS->name,
                              $USERS->email,
                              $SETTINGS->website,
                              $SETTINGS->email,
                              '['.$SETTINGS->website.'] '.$msg_tplnewticket25.$new_ticket,
                              $MSP_MAIL->template('templates/email/new_ticket.txt')
                              );
        }
      }
      
      // Send auto responder to person who opened ticket..
      $MSP_MAIL->sendMail($name,
                          $email,
                          $SETTINGS->website,
                          $SETTINGS->email,
                          '['.$SETTINGS->website.'] '.$msg_tplnewticket24,
                          $MSP_MAIL->template('templates/email/auto_responder.txt')
                          );
      
      // Build message that ticket was created..
      $OK  = new mailClass();
      $OK->addTag('{tpl_display_message}','<span class="error">'.msg('','ok',$email,$new_ticket).'</span>');
      $OK->addTag('{tpl_display_image}','<img class="messageImage" src="images/thanks.gif" alt="'.$msg_tplnewticket23.'" title="'.$msg_tplnewticket23.'">');
      $ticketMsg = $OK->template('templates/data_tables/message_table.tpl');
      $OK->clearVars();
      
      // Clear post vars..
      $name      = '';
      $email     = '';
      $subject   = '';
      $comments  = '';
    }
  }
  
  include(FOLDER_PATH.'inc/header.php');

  //Get departments..
  $d_data = '';
  $q_dept = mysql_query("SELECT * FROM ".$database['prefix']."departments ORDER BY name") or die(mysql_error());
      
  if (mysql_num_rows($q_dept)>0)
  {
    while ($DEPT = mysql_fetch_object($q_dept))
    {
      $d_data .= '<option value="'.$DEPT->id.'"'.(isset($dept) && $dept==$DEPT->id ? ' selected' : '').'>'.cleanData($DEPT->name).'</option>';
    }
  }

  // Are attachments enabled?
  if ($SETTINGS->attachment)
  {
    $ATTACHMENT  = new mailClass();
    $ATTACHMENT->addTag('{tpl_class_cell}','attachmentCreateCell');
    $ATTACHMENT->addTag('{msg_tplshowticket6}',$msg_tplnewticket14);
    $ATTACHMENT->addTag('{msg_script12}',$msg_script12);
    $ATTACHMENT->addTag('{msg_attach_enable}',attachmentDisplayMessage().($SETTINGS->filetypes ? '<br><br>'.$msg_javascript23.'<br>'.str_replace(",", " | ", $SETTINGS->filetypes) : '').($SETTINGS->maxsize ? '<br><br>'.$msg_javascript24.maxSize(): ''));
    $ATTACHMENT->addTag('{msg_javascript2}',$msg_javascript2);
    $attachFile = $ATTACHMENT->template('templates/data_tables/attachment_cell.tpl');
    $ATTACHMENT->clearVars();
  }
  
  // Are we showing the captcha?
  if ($SETTINGS->enCaptcha)
  {
    $CAPTCHA  = new mailClass();
    $CAPTCHA->addTag('{msg_tplnewticket26}',$msg_tplnewticket26);
    $CAPTCHA->addTag('{msg_tplnewticket27}',$msg_tplnewticket27);
    $CAPTCHA->addTag('{tpl_error}','');
    $captchaCode = $CAPTCHA->template('templates/data_tables/captcha_cell.tpl');
    $CAPTCHA->clearVars();
  }

  $tpl_ticket =& new Savant2();
  $tpl_ticket->assign('TABLEMESSAGE', $msg_tplnewticket);
  $tpl_ticket->assign('MESSAGE_TABLE', (isset($ticketMsg) ? $ticketMsg : ''));
  $tpl_ticket->assign('MESSAGE', $msg_tplnewticket2);
  $tpl_ticket->assign('MULTIPART', ($SETTINGS->attachment ? ' enctype="multipart/form-data"' : ''));
  $tpl_ticket->assign('DEPTTEXT', $msg_tplnewticket6);
  $tpl_ticket->assign('DEPARTMENTS', $d_data);
  $tpl_ticket->assign('NAMETEXT', $msg_tplnewticket3);
  $tpl_ticket->assign('EMAILTEXT', $msg_tplnewticket4);
  $tpl_ticket->assign('SUBJECTTEXT', $msg_tplnewticket15);
  $tpl_ticket->assign('SUBJECTMAX', $msg_tplnewticket16);
  $tpl_ticket->assign('COMMENTSTEXT', $msg_tplnewticket7);
  $tpl_ticket->assign('N_VALUE', (isset($name) ? cleanData($name) : ''));
  $tpl_ticket->assign('E_VALUE', (isset($email) ? cleanData($email) : ''));
  $tpl_ticket->assign('S_VALUE', (isset($subject) ? cleanData($subject) : ''));
  $tpl_ticket->assign('C_VALUE', (isset($comments) ? cleanData($comments) : ''));
  $tpl_ticket->assign('PRIORITYTEXT', $msg_tplnewticket8);
  $tpl_ticket->assign('PRIORITY_1', (isset($priority) && $priority==1 ? ' selected' : (!isset($priority) ? ' selected' : '')));
  $tpl_ticket->assign('PRIORITY_2', (isset($priority) && $priority==2 ? ' selected' : ''));
  $tpl_ticket->assign('PRIORITY_3', (isset($priority) && $priority==3 ? ' selected' : ''));
  $tpl_ticket->assign('TEXTLOW', $msg_tplnewticket9);
  $tpl_ticket->assign('TEXTMEDIUM', $msg_tplnewticket10);
  $tpl_ticket->assign('TEXTHIGH', $msg_tplnewticket11);
  $tpl_ticket->assign('TEXTSUBMIT', ($SETTINGS->kbase ? $msg_tplnewticket13.' &raquo;' : $msg_tplnewticket12));
  $tpl_ticket->assign('TEXTCANCEL', $msg_user25);
  $tpl_ticket->assign('ATTACHMENT', (isset($attachFile) ? $attachFile : ''));
  $tpl_ticket->assign('JAVASCRIPT_1', $msg_javascript21);
  $tpl_ticket->assign('JAVASCRIPT_2', $msg_javascript2);
  $tpl_ticket->assign('JAVASCRIPT_3', $msg_javascript26);
  $tpl_ticket->assign('JAVASCRIPT_4', $msg_javascript27);
  $tpl_ticket->assign('JAVASCRIPT_5', $msg_javascript28);
  $tpl_ticket->assign('JAVASCRIPT_6', $msg_javascript29);
  $tpl_ticket->assign('JAVASCRIPT_7', $msg_javascript19);
  $tpl_ticket->assign('SHOW_CAPTCHA', (isset($captchaCode) ? $captchaCode : ''));
  $tpl_ticket->display('templates/new_ticket.tpl.php');
      
  include(FOLDER_PATH.'inc/footer.php');
  break;
      
  case "showticket":
      
  //-----------------------
  // SCRIPT ACTION
  // Close/Open Ticket
  //-----------------------
      
  if (isset($_GET['action']) && ($_GET['action']=="close" || $_GET['action']=="open"))
  {
    $e = strip_tags($_GET['e']);
    $t = strip_tags($_GET['t']);
           
    mysql_query("UPDATE ".$database['prefix']."tickets SET 
                 status          = '".($_GET['action']=="open" ? 1 : 0)."' 
                 WHERE ticketid  = '$t' 
                 AND permaClose  = '0'
                 LIMIT 1
                 ") or die(mysql_error());
          
    header("Location: index.php?cmd=showticket&e=$e&t=$t");
  }
  
  //-----------------------
  // SCRIPT ACTION
  // Add Visitor Response
  //-----------------------
      
  if (isset($_POST['add']))
  {
    $id           = $_POST['id'];
    $name         = $_POST['name'];
    $ticketid     = $_POST['ticketid'];
    $subject      = $_POST['subject'];
    $dept         = $_POST['dept'];
    $deptid       = $_POST['deptid'];
    $priority     = $_POST['priority'];
    $email        = $_POST['email'];
    $file         = $_POST['file'];
    $comments     = cleanEvilTags($_POST['comments']);
    $close        = (isset($_POST['close']) ? 1 : 0);
    $ts           = $_POST['ts'];
    
    // Are attachments enabled?
    // To prevent problems with file name with spaces or other chars, rename..
    if ($SETTINGS->attachment)
    {
      if ($_FILES['attachment']['name']!='')
      {
        $file_name  = $MSP_TICKET->renameAttachmentFile($_FILES['attachment']['name'],$file);
        $file_temp  = $_FILES['attachment']['tmp_name'];
        $file_size  = $_FILES['attachment']['size'];
      }
    }
    
    $MSP_TICKET->attachment  = (isset($file_name) ? $file_name : '');
    $MSP_TICKET->filesize    = (isset($file_size) ? $file_size : 0);
    $MSP_TICKET->maxsize     = $SETTINGS->maxsize;
    $MSP_TICKET->filetypes   = $SETTINGS->filetypes;
    $MSP_TICKET->attstatus   = (isset($file_name) ? 1 : 0);

    if ($MSP_TICKET->field_check(0,0,$comments))
    {
      $error_string[] = $msg_viewticket19;
      $c_check        = true;
    }
    if (!isset($c_check) && ban_filter_check('words',$comments))
    {
      $error_string[] = $msg_tplnewticket33;
    }
    if (isset($file_name) && (isset($file_temp) && $file_temp))
    {
      if (!$MSP_TICKET->check_file_size() && $SETTINGS->maxsize)
      {
        $error_string[] = $msg_tplnewticket21;
        $a_error        = true;
      }
      if (!$MSP_TICKET->check_type() && $SETTINGS->filetypes)
      {
        $error_string[] = $msg_tplnewticket22;
        $a_error        = true;
      }
      if (isset($a_error))
      {
        if (file_exists($file_temp))
        {
          @unlink($file_temp);
        }
      }
    }
    if (!empty($error_string))
    {
      $ERRORS  = new mailClass();
      $ERRORS->addTag('{tpl_display_message}','<span class="error">'.msg($error_string).'</span>');
      $ERRORS->addTag('{tpl_display_image}','<img class="messageImage" src="images/error.gif" alt="'.$msg_script9.'" title="'.$msg_script9.'">');
      $ticketMsg = $ERRORS->template('templates/data_tables/message_table.tpl');
      $ERRORS->clearVars();
    }
    else
    {
      // Generate zip file attachment name..
      // If the original file was a zip file, use the same name..
      $zip_file              = ($file && substr($file,-4)=='.zip' ? $file : rand(11,99).time().'_attach.zip');
      
      $MSP_TICKET->attach    = (isset($file_name) ? $msg_script5 : $msg_script6);
      $MSP_TICKET->id        = $id;
      $MSP_TICKET->date      = date($SETTINGS->dateformat, strtotime("".$SETTINGS->timeOffset." hours"));
      $MSP_TICKET->name      = $name;
      $MSP_TICKET->ticketid  = $ticketid;
      $MSP_TICKET->subject   = $subject;
      $MSP_TICKET->dept      = $dept;
      $MSP_TICKET->priority  = priorityLevel($priority);
      $MSP_TICKET->email     = $email;
      $MSP_TICKET->comments  = $comments;
      $MSP_TICKET->close     = $close;
      $MSP_TICKET->perm      = 0;
      $MSP_TICKET->ts        = $ts;
      $MSP_TICKET->days      = $msg_script17;
      $MSP_TICKET->hours     = $msg_script18;
      $MSP_TICKET->mins      = $msg_script19;
      $MSP_TICKET->days2     = $msg_script20;
      $MSP_TICKET->hours2    = $msg_script21;
      $MSP_TICKET->mins2     = $msg_script22;
      $MSP_TICKET->month     = $msg_script24;
      $MSP_TICKET->status    = ($close ? $msg_viewticket12 : $msg_viewticket11);
      $MSP_TICKET->zipfile   = (isset($file_name) ? ($SETTINGS->auto_zip ? $zip_file : $file_name) : '');
      $MSP_TICKET->temp      = (isset($file_temp) ? $file_temp : '');
               
      // If an attachment is present, upload it..
      if (isset($file_name))
      {
        $MSP_TICKET->upload_file();
      }

      // If auto zipping is enabled, zip file..
      if (isset($file_name) && $SETTINGS->auto_zip)
      {
        include(FOLDER_PATH.'classes/class_zipcompression.inc.php');

        $MSP_ZIP = new createZip();

        if (file_exists('images/attachments/'.$file_name))
        {
          $MSP_ZIP->AddDirectory($ticketid.'_attachment/');

          $getContents = file_get_contents('images/attachments/'.$file_name);

          $MSP_ZIP->addFile($getContents, $ticketid.'_attachment/'.$file_name);

          $ZIPFILENAME  = 'images/attachments/'.$zip_file;
          $fd           = fopen ($ZIPFILENAME, "wb");
          $out          = fwrite ($fd, $MSP_ZIP->getZippedfile());
          fclose ($fd);
                          
          @unlink('images/attachments/'.$file_name);     
        }
      }
               
      // Add reply to database..
      $MSP_TICKET->add_visitor_reply();
      
      // Build mail tags..
      $MSP_MAIL->addTag('{NAME}', $name);
      $MSP_MAIL->addTag('{DATE}', date($SETTINGS->dateformat, strtotime("".$SETTINGS->timeOffset." hours")));
      $MSP_MAIL->addTag('{TICKET}', $ticketid);
      $MSP_MAIL->addTag('{SUBJECT}', $subject);
      $MSP_MAIL->addTag('{DEPT}', deptName($deptid));
      $MSP_MAIL->addTag('{PRIORITY}', priorityLevel($priority));
      $MSP_MAIL->addTag('{STATUS}', $msg_viewticket11);
      $MSP_MAIL->addTag('{ATTACHMENT}', (isset($file_name) && $file_name ? $msg_script5 : $msg_script6));
      $MSP_MAIL->addTag('{LINK}', 'index.php?cmd=showticket&e='.$email.'&t='.$ticketid);
      $MSP_MAIL->addTag('{ADMINLINK}', 'index.php?cmd=viewticket&id='.$id);
      $MSP_MAIL->addTag('{COMMENTS}', $comments);
      
      // Send message to support team..
      $q_webmasters = mysql_query("SELECT * FROM ".$database['prefix']."users 
                                   WHERE department  = '$deptid' 
                                   OR department     = '0'
                                   ") or die(mysql_error());
                                   
      while ($USERS = mysql_fetch_object($q_webmasters))
      {
        if ($USERS->notify)
        {                            
          $MSP_MAIL->sendMail($USERS->name,
                              $USERS->email,
                              $SETTINGS->website,
                              $SETTINGS->email,
                              '['.$SETTINGS->website.'] '.$msg_viewticket21.$ticketid,
                              $MSP_MAIL->template('templates/email/new_response.txt')
                              );
        }
      }
      
      // Build message that ticket was created..
      $OK  = new mailClass();
      $OK->addTag('{tpl_display_message}','<span class="error">'.msg('','response').'</span>');
      $OK->addTag('{tpl_display_image}','<img class="messageImage" src="images/thanks.gif" alt="'.$msg_tplshowticket8.'" title="'.$msg_tplshowticket8.'">');
      $ticketMsg = $OK->template('templates/data_tables/message_table.tpl');
      $OK->clearVars();
      
      // Clear comments..
      $comments = '';
    }
  }
      
  $header_view     = '';
  $header_message  = '';
  
  //-----------------------
  // SCRIPT ACTION
  // Get Ticket Data
  //-----------------------
      
  $ticket  = (isset($_GET['t']) ? strip_tags($_GET['t']) : (isset($ticketid) ? $ticketid : ''));
  $email   = (isset($_GET['e']) ? strip_tags($_GET['e']) : (isset($email) ? $email : ''));
           
  //----------------------------------
  // Query Database for ticket data
  //----------------------------------

  $q_ticket = mysql_query("SELECT * FROM ".$database['prefix']."tickets 
                           WHERE ticketid   = '$ticket' 
                           AND email        = '$email' 
                           AND livesupport  = '0' 
                           LIMIT 1
                           ") or die(mysql_error());
  $VIEW = mysql_fetch_object($q_ticket);
           
  if (mysql_num_rows($q_ticket)>0)
  {
    // Has this ticket got an attachment?
    if ($VIEW->attachstatus)
    {
      $MSP_ATTACH_CELL  = new mailClass();
      $MSP_ATTACH_CELL->addTag('{msg_viewticket29}',$msg_viewticket29);
      $MSP_ATTACH_CELL->addTag('{tpl_attachfile}',$VIEW->attachfile);
      $MSP_ATTACH_CELL->addTag('{tpl_size}',getAttachmentFileSize($VIEW->attachfile));
      $attachCell = $MSP_ATTACH_CELL->template('templates/data_tables/view_download_attachment.tpl');
      $MSP_ATTACH_CELL->clearVars();
    }
    
    $header_view     = strtoupper($msg_viewticket).' (#'.$ticket.')';
    $header_message  = $msg_tplshowticket3;
           
    // Firstly, lets build the ticket table..
    // We can use the mail class functions for this..
    $MSP_TICKET_TABLE  = new mailClass();
    $MSP_TICKET_TABLE->addTag('{msg_tplnewticket15}',$msg_tplnewticket15);
    $MSP_TICKET_TABLE->addTag('{tpl_subject}',($VIEW->livesupport ? $msg_viewticket36 : cleanData($VIEW->subject)));
    $MSP_TICKET_TABLE->addTag('{msg_viewticket6}',$msg_viewticket6);
    $MSP_TICKET_TABLE->addTag('{tpl_name}',cleanData($VIEW->name));
    $MSP_TICKET_TABLE->addTag('{msg_tplnewticket4}',$msg_tplnewticket4);
    $MSP_TICKET_TABLE->addTag('{tpl_email}',$VIEW->email);
    $MSP_TICKET_TABLE->addTag('{msg_tplnewticket6}',$msg_tplnewticket6);
    $MSP_TICKET_TABLE->addTag('{tpl_department}',cleanData($VIEW->department));
    $MSP_TICKET_TABLE->addTag('{msg_viewticket9}',$msg_viewticket9);
    $MSP_TICKET_TABLE->addTag('{tpl_open_close}',($VIEW->permaClose ? '<span class="error">'.$msg_tplnewticket34.'</span>' : ($VIEW->status ? '<span class="error">'.$msg_viewticket11.'</span> [<a href="index.php?cmd=showticket&amp;action=close&amp;e='.$VIEW->email.'&amp;t='.$VIEW->ticketid.'" title="'.$msg_viewticket10.'">'.$msg_viewticket10.'</a>]' : '<span class="error">'.$msg_viewticket12.'</span> [<a href="index.php?cmd=showticket&amp;action=open&amp;e='.$VIEW->email.'&amp;t='.$VIEW->ticketid.'" title="'.$msg_viewticket11.'">'.$msg_viewticket11.'</a>]')));
    $MSP_TICKET_TABLE->addTag('{msg_open15}',$msg_open15);
    $MSP_TICKET_TABLE->addTag('{tpl_live_support_status}',($VIEW->livesupport ? $msg_script5 : $msg_script6));
    $MSP_TICKET_TABLE->addTag('{msg_viewticket8}',$msg_viewticket8);
    $MSP_TICKET_TABLE->addTag('{tpl_postdate}',$VIEW->postdate);
    $MSP_TICKET_TABLE->addTag('{msg_viewticket7}',$msg_viewticket7);
    $MSP_TICKET_TABLE->addTag('{tpl_ip}',$VIEW->ip);
    $MSP_TICKET_TABLE->addTag('{msg_tplnewticket8}',$msg_tplnewticket8);
    $MSP_TICKET_TABLE->addTag('{p_name}',($VIEW->priority==3 ? '<span style="color:red;">'.priorityLevel(3).'</span>' : priorityLevel($VIEW->priority)));
    $MSP_TICKET_TABLE->addTag('{comments}',$MSP_TICKET->convert_bbcode(nl2br(cleanData($VIEW->comments))));
    $MSP_TICKET_TABLE->addTag('{tpl_attachment}',(isset($attachCell) ? $attachCell : ''));
    
    // Are there any replies to this ticket..
    $replyData     = '';
    $replyBoxData  = '';
    $MSP_REPLIES   = new mailClass();

    $q_replies = mysql_query("SELECT * FROM ".$database['prefix']."replies 
                              WHERE ticketid = '".$VIEW->ticketid."' 
                              ORDER BY posttime ASC
                              ") or die(mysql_error());

    while ($REPLY = mysql_fetch_assoc($q_replies))
    {
      $ticket_date = $REPLY['posttime'];
      $MSP_REPLIES->addTag('{tpl_class_table}',($REPLY['adminreply'] ? 'adminReplyCell' : 'visitorReplyCell'));
      $MSP_REPLIES->addTag('{msg_viewticket23}',$msg_viewticket23);
      $MSP_REPLIES->addTag('{tpl_name}',cleanData($REPLY['name']));
      $MSP_REPLIES->addTag('{comments}',$MSP_TICKET->convert_bbcode(nl2br(cleanData($REPLY['comments']))));
      $MSP_REPLIES->addTag('{msg_viewticket24}',$msg_viewticket24);
      $MSP_REPLIES->addTag('{tpl_responsetime}',$REPLY['responsetime']);
      $MSP_REPLIES->addTag('{tpl_reply_info_cell}',($REPLY['adminreply'] ? 'adminReplyInfoCell' : 'visitorReplyInfoCell'));
      $MSP_REPLIES->addTag('{tpl_postdate}',$REPLY['postdate']);
      $replyData .= $MSP_REPLIES->template('templates/data_tables/ticket_replies_table.tpl');
      $MSP_REPLIES->clearVars();
    }
        
    // Show no replies..
    if (mysql_num_rows($q_replies)==0)
    {
      $MSP_REPLIES->addTag('{msg_viewticket22}',$msg_viewticket22);
      $replyData .= $MSP_REPLIES->template('templates/data_tables/no_replies_table.tpl');
      $MSP_REPLIES->clearVars();
    }
      
    $MSP_REPLY_BOX = new mailClass();  
        
    // Onlys show reply box if ticket is open..
    if ($VIEW->status)
    {
      // Are attachments enabled?
      if ($SETTINGS->attachment)
      {
        $MSP_REPLY_BOX->addTag('{tpl_class_cell}','attachmentCell');
        $MSP_REPLY_BOX->addTag('{msg_tplshowticket6}',$msg_tplshowticket6);
        $MSP_REPLY_BOX->addTag('{msg_script12}',$msg_script12);
        $MSP_REPLY_BOX->addTag('{msg_attach_enable}',attachmentDisplayMessage().($SETTINGS->filetypes ? '<br><br>'.$msg_javascript23.'<br>'.str_replace(",", " | ", $SETTINGS->filetypes) : '').($SETTINGS->maxsize ? '<br><br>'.$msg_javascript24.maxSize(): ''));
        $MSP_REPLY_BOX->addTag('{msg_javascript2}',$msg_javascript2);
        $attachFile = $MSP_REPLY_BOX->template('templates/data_tables/attachment_cell.tpl');
        $MSP_REPLY_BOX->clearVars();
      }
      
      $MSP_REPLY_BOX->addTag('{msg_viewticket3}',strtoupper($msg_viewticket3));
      $MSP_REPLY_BOX->addTag('{tpl_id}',$VIEW->id);
      $MSP_REPLY_BOX->addTag('{tpl_name}',cleanData($VIEW->name));
      $MSP_REPLY_BOX->addTag('{tpl_ticketid}',$VIEW->ticketid);
      $MSP_REPLY_BOX->addTag('{tpl_subject}',cleanData($VIEW->subject));
      $MSP_REPLY_BOX->addTag('{tpl_department}',cleanData($VIEW->department));
      $MSP_REPLY_BOX->addTag('{tpl_deptid}',$VIEW->deptid);
      $MSP_REPLY_BOX->addTag('{tpl_priority}',$VIEW->priority);
      $MSP_REPLY_BOX->addTag('{tpl_file}',$VIEW->attachfile);
      $MSP_REPLY_BOX->addTag('{tpl_email}',$VIEW->email);
      $MSP_REPLY_BOX->addTag('{tpl_comment_reply}', (isset($comments) ? cleanData($comments) : ''));
      $MSP_REPLY_BOX->addTag('{tpl_close_option}', (isset($close) && $close ? ' checked' : ''));
      $MSP_REPLY_BOX->addTag('{tpl_ticketdate}',(isset($ticket_date) ? $ticket_date : $VIEW->ticketdate));
      $MSP_REPLY_BOX->addTag('{multi_part}',($SETTINGS->attachment ? ' enctype="multipart/form-data"' : ''));
      $MSP_REPLY_BOX->addTag('{msg_javascript19}',$msg_javascript19);
      $MSP_REPLY_BOX->addTag('{msg_javascript16}',$msg_javascript16);
      $MSP_REPLY_BOX->addTag('{msg_javascript17}',$msg_javascript17);
      $MSP_REPLY_BOX->addTag('{msg_javascript27}',$msg_javascript27);
      $MSP_REPLY_BOX->addTag('{msg_javascript2}',$msg_javascript2);
      $MSP_REPLY_BOX->addTag('{msg_tplshowticket5}',$msg_tplshowticket5);
      $MSP_REPLY_BOX->addTag('{attachment}',(isset($attachFile) ? $attachFile : ''));
      $MSP_REPLY_BOX->addTag('{msg_viewticket3}',$msg_viewticket3);
      $replyBoxData = $MSP_REPLY_BOX->template('templates/data_tables/reply_box_table.tpl');
      $MSP_REPLY_BOX->clearVars();
    }
    else
    {
      $MSP_REPLY_BOX->addTag('{msg_viewticket22}',$msg_viewticket5);
      $replyBoxData = $MSP_REPLY_BOX->template('templates/data_tables/no_replies_table.tpl');
      $MSP_REPLY_BOX->clearVars();
    }
  }
  else
  {
    // If this ticket isn`t found, redirect to main page
    // This will load if someone has an old ticket url bookmarked
    header("Location: index.php?noticket=1");
    exit;
  }

  include(FOLDER_PATH.'inc/header.php');

  $tpl_showticket =& new Savant2();
  $tpl_showticket->assign('TABLEMESSAGE', $header_view);
  $tpl_showticket->assign('MESSAGE_TABLE', (isset($ticketMsg) ? $ticketMsg : ''));
  $tpl_showticket->assign('NEWTICKET', strtoupper($msg_tplshowticket4));
  $tpl_showticket->assign('TICKET_TABLE', $MSP_TICKET_TABLE->template('templates/data_tables/ticket_table.tpl'));
  $tpl_showticket->assign('MESSAGE', $header_message);
  $tpl_showticket->assign('REPLY_DATA', $replyData);
  $tpl_showticket->assign('REPLY_BOX_DATA', $replyBoxData);
  $tpl_showticket->display('templates/show_ticket.tpl.php');

  include(FOLDER_PATH.'inc/footer.php');

  break;
      
  //==============================
  // Live Support
  // Added in v1.2
  //==============================
      
  case 'livesupport':
      
  $copyrightinfo  = '<br>&copy; ' . (date("Y")=='2005' ? '2005' : '2005-' . date("Y")) . ' Maian Script World. '.$msg_script26;
  $scriptinfo     = '<b>'.$msg_script3 . '</b>: <a href="http://www.maianscriptworld.co.uk/scripts_support.html" title="' . $msg_script . ' ' . $msg_script2 . '" target="_blank">' . $msg_script . ' ' . $msg_script2 . '</a>';
  $html   = '';

  //-----------------------------
  // Is live support enabled?
  // Is dept valid?
  //-----------------------------

  if (!$SETTINGS->enablelive || (isset($_GET['dept']) && !is_numeric($_GET['dept'])) || !isset($_GET['dept']) && (!isset($_POST['stepOne'])))
  {
    $tpl_error =& new Savant2();
    $tpl_error->assign('CHARSET', $msg_charset);
    $tpl_error->assign('TITLE', $msg_livesupport);
    $tpl_error->assign('MESSAGE', $msg_livesupport8);
    $tpl_error->assign('CLOSEWINDOW', $msg_script11);
    $tpl_error->assign('COPYRIGHT', $scriptinfo.' '.$copyrightinfo);
    $tpl_error->display('templates/livesupport/error.tpl.php');
    exit;
  }
      
  //----------------------
  // Check dept name
  //----------------------

  if (isset($_GET['dept']))
  {
    $q_dept = mysql_query("SELECT name FROM ".$database['prefix']."departments WHERE id = '".$_GET['dept']."' LIMIT 1") or die(mysql_error());
    $DEPT = mysql_fetch_object($q_dept);
        
    if (mysql_num_rows($q_dept)==0)
    {
      $tpl_error =& new Savant2();
      $tpl_error->assign('CHARSET', $msg_charset);
      $tpl_error->assign('TITLE', $msg_livesupport);
      $tpl_error->assign('MESSAGE', $msg_livesupport15);
      $tpl_error->assign('CLOSEWINDOW', $msg_script11);
      $tpl_error->assign('COPYRIGHT', $scriptinfo.' '.$copyrightinfo);
      $tpl_error->display('templates/livesupport/error.tpl.php');
      exit;
    }
  }

  //-----------------------
  // Stage One
  // Process Question
  //-----------------------
      
  if (isset($_GET['ls_process']))
  {
    $ticket = $_GET['ticket'];
    $dept   = $_GET['dept'];
    $reply  = (isset($_GET['reply']) ? 1 : 0);

    $MSP_TICKET->ticketid = $ticket;

    // Has a response been made?
    // Check ticket response
        
    if ($MSP_TICKET->check_live_response())
    {
      $ADMIN = $MSP_TICKET->get_response();
      $VIS   = $MSP_TICKET->getTicket($ticket,true);

      $tpl_response =& new Savant2();
      $tpl_response->assign('CHARSET', $msg_charset);
      $tpl_response->assign('TITLE', $msg_livesupport);
      $tpl_response->assign('REPLYBY', '<b>'.$msg_livesupport13.'</b> '.cleanData($ADMIN->name));
      $tpl_response->assign('SHOWRESPONSE', $MSP_TICKET->convert_bbcode(nl2br(cleanData($ADMIN->comments))));
      $tpl_response->assign('DEPT', $dept);
      $tpl_response->assign('TICKET', $ticket);
      $tpl_response->assign('NAME', cleanData($VIS->name));
      $tpl_response->assign('EMAIL', $VIS->email);
      $tpl_response->assign('ADDNEWREPLY', $msg_livesupport12);
      $tpl_response->assign('CLOSEWINDOW', $msg_script11);
      $tpl_response->assign('COPYRIGHT', $scriptinfo.' '.$copyrightinfo);
      $tpl_response->display('templates/livesupport/response.tpl.php');
    }
    else
    {
      //-----------------------------------------------------
      // Check how much time has elapsed since submission
      // If timeout is reached, display message
      //-----------------------------------------------------

      $MSP_TICKET->ts  = $MSP_TICKET->get_timestamp(($reply ? true : false));
      $rTime           = $MSP_TICKET->response_time(true);

      if (is_numeric($rTime) && ($rTime >= $SETTINGS->timeout))
      {
        $tpl_timeout =& new Savant2();
        $tpl_timeout->assign('CHARSET', $msg_charset);
        $tpl_timeout->assign('TITLE', $msg_livesupport);
        $tpl_timeout->assign('REPLYBY', '<b>'.$msg_livesupport13.'</b> '.cleanData($SETTINGS->website));
        $tpl_timeout->assign('SHOWRESPONSE', $msg_livesupport16);
        $tpl_timeout->assign('CLOSEWINDOW', $msg_script11);
        $tpl_timeout->assign('COPYRIGHT', $scriptinfo.' '.$copyrightinfo);
        $tpl_timeout->display('templates/livesupport/timeout.tpl.php');
      }
      else
      {
        $tpl_refresh =& new Savant2();
        $tpl_refresh->assign('CHARSET', $msg_charset);
        $tpl_refresh->assign('TITLE', $msg_livesupport);
        $tpl_refresh->assign('REFRESH', '<meta http-equiv="refresh" content="'.$SETTINGS->liverefresh.';url=index.php?cmd=livesupport&amp;ls_process=1'.($reply ? '&amp;reply=1' : '').'&amp;dept='.$dept.'&amp;ticket='.$ticket.'">');
        $tpl_refresh->assign('REFRESHMESSAGE', $msg_livesupport10);
        $tpl_refresh->assign('PLEASEWAIT', $msg_livesupport9);
        $tpl_refresh->assign('CLOSEWINDOW', $msg_script11);
        $tpl_refresh->assign('COPYRIGHT', $scriptinfo.' '.$copyrightinfo);
        $tpl_refresh->display('templates/livesupport/refresh.tpl.php');
      }
    }

    exit;
  }
      
  if (isset($_POST['stepOne']))
  {
    $name      = cleanEvilTags($_POST['name'],true);
    $email     = trim($_POST['email']);
    $question  = cleanEvilTags($_POST['question']);
    $ticketID  = $_POST['ticketID'];

    $count     = 0;

    if ($name=='')
    {
      $N_ERROR = '<br><span class="ls_error">'.$msg_livesupport4.'</span>';
      $count++;
    }
    if (!eregi("^([a-z]|[0-9]|\.|-|_)+@([a-z]|[0-9]|\.|-|_)+\.([a-z]|[0-9]){2,4}$", $email))
    {
      $E_ERROR = '<br><span class="ls_error">'.$msg_livesupport5.'</span>';
      $count++;
    }
    if ($question=='')
    {
      $Q_ERROR = '<br><span class="ls_error">'.$msg_livesupport6.'</span>';
      $count++;
    }
    if (isset($_POST['code']) && $SETTINGS->enLiveCaptcha)
    {
      if (!PhpCaptcha::Validate(trim($_POST['code'])))
      {
        $C_ERROR = '<br><span class="ls_error">'.$msg_livesupport7.'</span>';
        $count++;
      }
    }
        
    if ($count==0)
    {
      $new_ticket               = $MSP_TICKET->ticket_id();
      $MSP_TICKET->dept        = cleanData($DEPT->name);
      $MSP_TICKET->deptid      = $_GET['dept'];
      $MSP_TICKET->name        = $name;
      $MSP_TICKET->email       = $email;
      $MSP_TICKET->comments    = $question;
      $MSP_TICKET->priority    = $msg_tplnewticket11;
      $MSP_TICKET->priority2   = '3';
      $MSP_TICKET->date        = date($SETTINGS->dateformat, strtotime("".$SETTINGS->timeOffset." hours"));
      $MSP_TICKET->ticketid    = ($ticketID ? $ticketID : $new_ticket);
      $MSP_TICKET->attstatus   = 0;
      $MSP_TICKET->status      = $msg_viewticket11;
      $MSP_TICKET->days        = $msg_script17;
      $MSP_TICKET->hours       = $msg_script18;
      $MSP_TICKET->mins        = $msg_script19;
      $MSP_TICKET->days2       = $msg_script20;
      $MSP_TICKET->hours2      = $msg_script21;
      $MSP_TICKET->mins2       = $msg_script22;
      $MSP_TICKET->month       = $msg_script24;
          
      // If ticket id is present, visitor is adding new response
      // If this is the case, we need the timestamp of last post

      if ($ticketID)
      {
        $MSP_TICKET->ts        = $MSP_TICKET->get_timestamp(false);
      }

      // Is this a new ticket, or a response to a current one?
      // So, if ticket id is present its a response

      // Build mail tags..
      $MSP_MAIL->addTag('{NAME}', $name);
      $MSP_MAIL->addTag('{DATE}', date($SETTINGS->dateformat, strtotime("".$SETTINGS->timeOffset." hours")));
      $MSP_MAIL->addTag('{DEPT}', deptName($_GET['dept']));
      $MSP_MAIL->addTag('{PRIORITY}', priorityLevel(3));
      $MSP_MAIL->addTag('{STATUS}', $msg_viewticket11);
      $MSP_MAIL->addTag('{COMMENTS}', $question);
 
      if ($ticketID)
      {
        $id = $MSP_TICKET->getTicket($ticketID,true);
        
        $MSP_TICKET->add_visitor_reply(true,$ticketID);
        
        $MSP_MAIL->addTag('{TICKET}', $ticketID);
        $MSP_MAIL->addTag('{ADMINLINK}', 'index.php?cmd=viewticket&id='.$id->id);
        
        // Send message to support team..
        $q_webmasters = mysql_query("SELECT * FROM ".$database['prefix']."users 
                                     WHERE (department = '".$_GET['dept']."' 
                                     OR department     = '0') 
                                     AND livesupport   = '1'
                                     ") or die(mysql_error());
                                   
        while ($USERS = mysql_fetch_object($q_webmasters))
        {
          if ($USERS->notify)
          {                            
            $MSP_MAIL->sendMail($USERS->name,
                                $USERS->email,
                                $SETTINGS->website,
                                $SETTINGS->email,
                                '['.$SETTINGS->website.'] '.$msg_livesupport14.$ticketID,
                                $MSP_MAIL->template('templates/email/new_live_response.txt')
                                );
          }
        }
      }
      else
      {
        $id                    = $MSP_TICKET->new_live_support_ticket_sql();    
        $MSP_TICKET->insertID  = $id;
        
        $MSP_MAIL->addTag('{TICKET}', $new_ticket);
        $MSP_MAIL->addTag('{ADMINLINK}', 'index.php?cmd=viewticket&id='.$id);

        // Send message to support team..
        $q_webmasters = mysql_query("SELECT * FROM ".$database['prefix']."users 
                                     WHERE (department = '".$_GET['dept']."' 
                                     OR department     = '0') 
                                     AND livesupport   = '1'
                                     ") or die(mysql_error());
                                   
        while ($USERS = mysql_fetch_object($q_webmasters))
        {
          if ($USERS->notify)
          {                            
            $MSP_MAIL->sendMail($USERS->name,
                                $USERS->email,
                                $SETTINGS->website,
                                $SETTINGS->email,
                                '['.$SETTINGS->website.'] '.$msg_livesupport11.$ticketID,
                                $MSP_MAIL->template('templates/email/new_live_support.txt')
                                );
          }
        }
      }
          
      $tpl_refresh =& new Savant2();
      $tpl_refresh->assign('CHARSET', $msg_charset);
      $tpl_refresh->assign('TITLE', $msg_livesupport);
      $tpl_refresh->assign('REFRESH', '<meta http-equiv="refresh" content="'.$SETTINGS->liverefresh.';url=index.php?cmd=livesupport&amp;ls_process=1'.($ticketID ? '&amp;reply=1' : '').'&amp;dept='.$_GET['dept'].'&amp;ticket='.($ticketID ? $ticketID : $new_ticket).'">');
      $tpl_refresh->assign('REFRESHMESSAGE', $msg_livesupport10);
      $tpl_refresh->assign('PLEASEWAIT', $msg_livesupport9);
      $tpl_refresh->assign('CLOSEWINDOW', $msg_script11);
      $tpl_refresh->assign('COPYRIGHT', $scriptinfo.' '.$copyrightinfo);
      $tpl_refresh->display('templates/livesupport/refresh.tpl.php');
      exit;
    }
  }

  // Is captcha enabled for live support?
  if ($SETTINGS->enLiveCaptcha)
  {
    $CAPTCHA  = new mailClass();
    $CAPTCHA->addTag('{msg_tplnewticket26}',$msg_tplnewticket26);
    $CAPTCHA->addTag('{msg_tplnewticket27}',$msg_tplnewticket27);
    $CAPTCHA->addTag('{tpl_error}',(isset($C_ERROR) ? $C_ERROR : ''));
    $captchaCode = $CAPTCHA->template('templates/data_tables/captcha_cell.tpl');
    $CAPTCHA->clearVars();
  }
      
  //-------------------------------------------------------
  // If visitor is adding another question we
  //  can auto fill the name & email boxes for quickness
  //-------------------------------------------------------

  $nValue = (isset($_GET['name']) ? $_GET['name'] : '');
  $eValue = (isset($_GET['email']) ? $_GET['email'] : '');

  $tpl_livesupport =& new Savant2();
  $tpl_livesupport->assign('CHARSET', $msg_charset);
  $tpl_livesupport->assign('TITLE', $msg_livesupport);
  $tpl_livesupport->assign('SUPPORTMESSAGE', $msg_livesupport2);
  $tpl_livesupport->assign('NAMETEXT', $msg_user);
  $tpl_livesupport->assign('NAME_ERROR', (isset($N_ERROR) ? $N_ERROR : ''));
  $tpl_livesupport->assign('NAME_VALUE', (isset($name) ? cleanData($name) : cleanData($nValue)));
  $tpl_livesupport->assign('EMAIL_VALUE', (isset($email) ? cleanData($email) : cleanData($eValue)));
  $tpl_livesupport->assign('QUESTION_VALUE', (isset($question) ? cleanData($question) : ''));
  $tpl_livesupport->assign('EMAIL_ERROR', (isset($E_ERROR) ? $E_ERROR : ''));
  $tpl_livesupport->assign('QUESTION_ERROR', (isset($Q_ERROR) ? $Q_ERROR : ''));
  $tpl_livesupport->assign('EMAILTEXT', $msg_user4);
  $tpl_livesupport->assign('TICKETID', (isset($_GET['ticket']) ? $_GET['ticket'] : (isset($ticketID) ? $ticketID : '')));
  $tpl_livesupport->assign('CAPTCHA', (isset($captchaCode) ? $captchaCode : ''));
  $tpl_livesupport->assign('DEPTID', $_GET['dept']);
  $tpl_livesupport->assign('QUESTIONTEXT', $msg_kbase);
  $tpl_livesupport->assign('SUBMIT', $msg_livesupport3);
  $tpl_livesupport->assign('CLOSEWINDOW', $msg_script11);
  $tpl_livesupport->assign('COPYRIGHT', $scriptinfo.' '.$copyrightinfo);
  $tpl_livesupport->display('templates/livesupport/index.tpl.php');

  break;
  
  case 'captcha':
  
  $MSPC = new PhpCaptcha();
  $MSPC->Create();
  
  break;
}

?>
